%define name    adas
%define version 3.0.0
%define release csa8

Summary:    Aragats Data Acquisition Server
Name:       %{name}
Version:    %{version}
Release:    %{release}
Copyright:  GPL
Group:	    Drivers
Distribution:	DarkLin
Vendor:		DarkSoft
Packager:	Kain <ds7fff@myrealbox.com>
Source0:     %{name}-%{version}.tar.bz2
BuildRoot:  /var/tmp/%{name}-%{version}-root
Obsoletes:	namt
Requires: 	libds
BuildRequires: 	libds-devel

%description
Data Aquisition Software for ASEC monitors. 

Follwoing drivers are available:
    - Fujitsu MB91F364 based Multidirectional Muon Telescope
    - Neutron Telescope
Following interfaces are supported:
    - Standard UART interface
    - Ethernet UDP interface (1st Mile UART<->Ethernet converter)
Following data formats are supported:
    - Legacy ASCII representation
    - Self describing XML data
    - OPC XML-DA interface

%package client
Summary:	Aragats Data Acquisition Server
Group:		Drivers
Obsoletes:	namt-client

%description client
Ncurses client to monitor and control current state of the Data Acquisition System.

%package emu
Summary:	Aragats Data Acquisition Server
Group:		Drivers

%description emu
Software device emulators
    
%prep
%setup

%build
cd adas
make
cd ../clients
make
cd ../namt/emu
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/bin
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/etc/cron.hourly
mkdir -p $RPM_BUILD_ROOT/var/ftp/pub

install -m 755 adas/adas-srv $RPM_BUILD_ROOT/usr/bin
install -m 755 clients/adas-simple $RPM_BUILD_ROOT/usr/bin
install -m 755 namt/emu/namt-emu $RPM_BUILD_ROOT/usr/bin/

install -m 644 adas/adas.cfg $RPM_BUILD_ROOT/etc
install -m 755 misc/adas.init $RPM_BUILD_ROOT/etc/rc.d/init.d/adas

%post
if [ $1 = 1 ]; then
    if [ -f %{_sysconfdir}/rc.d/init.d/namt ]; then
	%{_sysconfdir}/rc.d/init.d/namt start
    fi
    chkconfig --add adas
    chkconfig --level 2345 adas on
else
    if [ -f %{_sysconfdir}/rc.d/init.d/adas ]; then
	%{_sysconfdir}/rc.d/init.d/adas restart
    fi
fi

%preun
if [ $1 = 0 ]; then
    if [ -f %{_sysconfdir}/rc.d/init.d/adas ]; then
	%{_sysconfdir}/rc.d/init.d/adas stop
    fi
    chkconfig --del adas
fi


%clean
rm -rf $RPM_BUILD_ROOT

%files
%config(noreplace) /etc/adas.cfg
/usr/bin/adas-srv
/etc/rc.d/init.d/adas
%dir /var/ftp/pub

%files client
/usr/bin/adas-simple

%files emu
/usr/bin/namt-emu
