#define _DS_INCLUDE_XML_HEADERS

#include <dsassert.h>
#include <dsconnection.h>

#include "connection.h"

int COMConnectionOpen(Connection ctx) {
    int err;
    xmlNodePtr cfg;

    DSConnectionCOMOptions options;

    ds_assert_param(ctx);

    options = dsConnectionCOMGetDefaultOptions();
    if (!options) return DS_ERR_MEM;

    cfg = dsConfigGetConfigByReference(ctx->cfg, ctx->cfgref);
    err = dsConnectionCOMOptionsSetSpeed(options, dsXmlGetNodeLong(cfg, "Speed", DS_DEFAULT_COM_SPEED));
    if (!err) err = dsConnectionConnectCOM(ctx->con, NULL, dsXmlGetNodeString(cfg, "Device", "/dev/ttyS0"), options);

    if (cfg) dsConfigReturnConfig(ctx->cfg, cfg);
    dsConnectionCOMDestroyOptions(options);

    return err;
}
