#define _DS_INCLUDE_XML_HEADERS
#define _NET_CONNECTION_C

#include <dsassert.h>
#include <dsconnection.h>

#include "connection.h"
#include "netconnection.h"


int NETConnectionOpen(Connection ctx) {
    int i;
    int err;
    xmlNodePtr cfg;
    ConnectFunction connect = NULL;
    const char *protoname;

    ds_assert_param(ctx);

    cfg = dsConfigGetConfigByReference(ctx->cfg, ctx->cfgref);
    
    protoname = dsXmlGetNodeString(cfg, "Protocol", DEFAULT_NETWORK_PROTOCOL);
    for (i=0;net_connection_configuration[i].name;i++) {
	if (!strcmp(protoname, net_connection_configuration[i].name)) {
	    connect = net_connection_configuration[i].connect;
	    break;
	}
    }
        
    if (connect) err = connect(ctx->con, NULL, dsXmlGetNodeString(cfg, "Server", NULL), dsXmlGetNodeInt(cfg, "Port", DEFAULT_NETWORK_PORT));
    else err = DS_ERR_INVALID_OPTIONS;
    
    if (cfg) dsConfigReturnConfig(ctx->cfg, cfg);

    return err;
}
