#ifndef _NET_CONNECTION_H
#define _NET_CONNECTION_H

#define DEFAULT_NETWORK_PROTOCOL "UDP"
#define DEFAULT_NETWORK_PORT 5001

int NETConnectionOpen(Connection ctx);

#ifdef _NET_CONNECTION_C

#include <dsconnection.h>

typedef int (*ConnectFunction)(DSConnectionContext ctx, DSSignalMask sigmask, const char *server, in_port_t port);

struct NETConnectionConfigurationT {
    const char *name;
    ConnectFunction connect;
};

typedef struct NETConnectionConfigurationT *NETConnectionConfiguration;
typedef struct NETConnectionConfigurationT NETConnectionConfigurationS;

static NETConnectionConfigurationS net_connection_configuration[] = {
    { "UDP", dsConnectionConnectUDPServer },
    { "TCP", dsConnectionConnectTCPServer },
    { NULL, NULL }
};
#endif /* _NET_CONNECTION_C */


#endif /* _NET_CONNECTION_H */
