#ifndef _LOW_LEVEL_H
#define _LOW_LEVEL_H

#include "connection/connection.h"

#define LL_ERR_TIMEOUT 		-1
#define LL_ERR_READ 		-2
#define LL_ERR_WRITE 		-3
#define LL_ERR_INIT 		-4
#define LL_ERR_IMPLEMENTED 	-5
#define LL_ERR_MEM		-6


/* Returns LL Errors */
int ReadByte(Connection ctx);
int ReadWord(Connection ctx);
int WriteByte(Connection ctx, unsigned char tmp);
int WriteWord(Connection ctx, unsigned short int tmp);

int SendSimple(Connection ctx, unsigned char cmd);
int SendAttribute(Connection ctx, unsigned char cmd, unsigned short int attr);
int SendData(Connection ctx, unsigned char cmd, unsigned short int isize, const char *ibuff);
int RequestAttribute(Connection ctx, unsigned char cmd, unsigned short int *attr);
int RequestData(Connection ctx, unsigned char cmd, unsigned short int *osize, char **obuff);
int RequestDataFixed(Connection ctx, unsigned char cmd, unsigned short int osize, char *obuff);
int ComplexRequestData(Connection ctx, unsigned cmd, unsigned short int attr, unsigned short int *osize, char **obuff);
int ComplexRequestDataFixed(Connection ctx, unsigned cmd, unsigned short int attr, unsigned short int osize, char *obuff);
int ComplexRequest(Connection ctx, unsigned char cmd, unsigned short int isize, const char *ibuff, unsigned short int *osize, char **obuff);
int SendChannelAttribute(Connection ctx, unsigned char cmd, unsigned short int channel, unsigned short int attr);
int RequestChannelAttribute(Connection ctx, unsigned char cmd, unsigned short int channel, unsigned short int *attr);


#endif /* _LOW_LEVEL_H */
