#ifndef _NAMT_H
#define _NAMT_H

#define NAMT_VERSION 3

#include <dstime.h>
#include <dsdispersion.h>

typedef struct NAMTDeviceT *NAMTDevice;

#include "device.h"
#include "namtreader.h"
#include "namtanalyzer.h"

struct NAMTDeviceT {
    DeviceS device;

    DSLockContext ilock;    

    DSTime datatime;
    DSDuration high_read_pause;
    DSDuration min_sync_error, max_sync_error;
    
    unsigned int rt_time;			/* Readout duration in ms */

    unsigned int recs;

    unsigned int data_size;


    unsigned long current_iteration;
    long diff;					/* synchronization indicator */
    long desync;

    unsigned short int protocol_version;
    unsigned short int device_type, device_version;
    unsigned long int handled_events;		/* Events handled by hardware */
    unsigned char max_devices, devices;
    unsigned short *detectors;
    
    unsigned char reset;
    unsigned char sf;				/* first iteration indicator */
    
    SpectrumPropertiesS spectrum;
    
    unsigned char write_events;
    unsigned short int write_spectrum;
    unsigned long int write_spectrum_last_iteration;
    DSDuration control_readout_required_time;
    unsigned long int read_control_last_iteration;
    unsigned short int read_control, write_control;

    double hv[MAX_NAMT_SENSORS], thresholds[MAX_NAMT_SENSORS];

    unsigned char plain;
    unsigned short int coincidences, spectrums;
    unsigned char prepare_sync;

    unsigned char layout;
    unsigned short layout_sensors;
    unsigned short layout_channels;
    unsigned short layout_rules;
    unsigned short layout_spectrums;
    
    NAMTAnalyzerS analyzer;
};

typedef struct NAMTDeviceT NAMTDeviceS;


Device namtDeviceCreate(DSConfigContext config, DSConfigReference ref);



#endif /* _NAMT_H */
