#ifndef _ANALYZER_H
#define _ANALYZER_H

#include <dstime.h>
#include "namtreader.h"

struct NAMTAnalyzerT {
    unsigned int iter;
    DSTime curtime;
    DSDuration duration;

    unsigned char devices;
    unsigned short *detectors;

    NAMTDetectorDataS *data;
    NAMTDetectorCDataS *cdata;
    DSCorrelationContext *cor;
    unsigned int *data_skiped, *cdata_skiped;
    
    DeviceWriter *writer;
};
typedef struct NAMTAnalyzerT NAMTAnalyzerS;
typedef struct NAMTAnalyzerT *NAMTAnalyzer;


#include "namtbuffer.h"
#include "namt.h"

void namtAnalyzerZero(NAMTDevice dev, NAMTAnalyzer ctx);
void namtAnalyzerFree(NAMTDevice dev, NAMTAnalyzer ctx);
int namtProcessor(NAMTDevice dev, NAMTReaderBuf buf);

#endif /* _ANALYZER_H */
