#ifndef _NAMT_BUFFER_H
#define _NAMT_BUFFER_H

#include "buffer.h"

typedef struct NAMTReaderBufT *NAMTReaderBuf;

#include "namtreader.h"

struct NAMTReaderBufT {
    ReaderBufS buf;
    
    unsigned char sf;
    unsigned short int device_type, device_version;
	
    unsigned char data_size;
    unsigned char devices;
    unsigned short *detectors;
    
    unsigned char plain;
    unsigned short int coincidences, spectrums;
    
    unsigned int rt_time;
    unsigned int recs;
	
    NAMTData *data;
    NAMTData *cdata;
    NAMTSpectrum *spectrum;
    NAMTEvents events;
    
    unsigned long current_iteration;
    unsigned long spectrum_iteration;

    long desync;    
    uint16_t errors;
};
typedef struct NAMTReaderBufT NAMTReaderBufS;

int namtBufferAdd(NAMTDevice dev, NAMTData *data, NAMTData *cdata, NAMTEvents events, NAMTSpectrum *spectrum, uint16_t errors);

#endif /* _NAMT_BUFFER_H */
