#ifndef _NAMT_LAYOUT_H
#define _NAMT_LAYOUT_H

#include "namt.h"
#include "dsxml.h"
int namtLayoutProcess(NAMTDevice dev, Connection con, xmlNodePtr layout);

enum LayoutRuleSetFlagsT {
    LAYOUT_RULESET_FLAGS_COUNT = 1,
    LAYOUT_RULESET_FLAGS_EVENTS = 2
};
typedef enum LayoutRuleSetFlagsT LayoutRuleSetFlags;

enum LayoutRuleSetTypeT {
    LAYOUT_RULESET_TYPE_UNKNOWN = 0,
    LAYOUT_RULESET_TYPE_CUSTOM,
    LAYOUT_RULESET_TYPE_NONE,
    LAYOUT_RULESET_TYPE_ONE,
    LAYOUT_RULESET_TYPE_SOME,
    LAYOUT_RULESET_TYPE_ALL,
    LAYOUT_RULESET_TYPE_SET,
    LAYOUT_RULESET_TYPE_OR,
    LAYOUT_RULESET_TYPE_AND
};
typedef enum LayoutRuleSetTypeT LayoutRuleSetType;

enum LayoutRuleTypeT {
    LAYOUT_RULE_TYPE_UNKNOWN = 0,
    LAYOUT_RULE_TYPE_SENSOR,
    LAYOUT_RULE_TYPE_RULESET
};
typedef enum LayoutRuleTypeT LayoutRuleType;

enum LayoutRuleTestT {
    LAYOUT_RULE_TEST_UNKNOWN = 0,
    LAYOUT_RULE_TEST_TRUE,
    LAYOUT_RULE_TEST_FALSE,
    LAYOUT_RULE_TEST_ABOVE,
    LAYOUT_RULE_TEST_BELOW
};
typedef enum LayoutRuleTestT LayoutRuleTest;

struct LayoutRuleSetTypesT {
    LayoutRuleSetType type;
    const char *id;
};
typedef struct LayoutRuleSetTypesT LayoutRuleSetTypesS;
typedef struct LayoutRuleSetTypesT *LayoutRuleSetTypes;

struct LayoutRuleTypesT {
    LayoutRuleType type;
    const char *id;
};
typedef struct LayoutRuleTypesT LayoutRuleTypesS;
typedef struct LayoutRuleTypesT *LayoutRuleTypes;

struct LayoutRuleTestsT {
    LayoutRuleTest type;
    const char *id;
};
typedef struct LayoutRuleTestsT LayoutRuleTestsS;
typedef struct LayoutRuleTestsT *LayoutRuleTests;

#ifdef _NAMT_LAYOUT_C
LayoutRuleSetTypesS layout_ruleset_types[] = {
    { LAYOUT_RULESET_TYPE_CUSTOM, "custom" },
    { LAYOUT_RULESET_TYPE_NONE, "none" },
    { LAYOUT_RULESET_TYPE_ONE, "one" },
    { LAYOUT_RULESET_TYPE_SOME, "some" },
    { LAYOUT_RULESET_TYPE_ALL, "all" },
    { LAYOUT_RULESET_TYPE_SET, "set" },
    { LAYOUT_RULESET_TYPE_OR, "or" },
    { LAYOUT_RULESET_TYPE_AND,  "and" },
    { LAYOUT_RULESET_TYPE_UNKNOWN, NULL}
};

LayoutRuleTypesS layout_rule_types[] = {
    { LAYOUT_RULE_TYPE_SENSOR, "sensor" },
    { LAYOUT_RULE_TYPE_RULESET, "coincidence" },
    { LAYOUT_RULE_TYPE_UNKNOWN, NULL}
};

LayoutRuleTestsS layout_rule_tests[] = {
    { LAYOUT_RULE_TEST_TRUE, "true" },
    { LAYOUT_RULE_TEST_FALSE, "false" },
    { LAYOUT_RULE_TEST_ABOVE, "above" },
    { LAYOUT_RULE_TEST_BELOW, "below" },
    { LAYOUT_RULE_TEST_UNKNOWN, NULL}
};

#endif /* _NAMT_LAYOUT_C */

#endif /* _NAMT_LAYOUT_H */
