#ifndef _NANM_H
#define _NANM_H

#define NANM_VERSION 1

#include <dstime.h>

#include "device.h"

#define 	NANM_BYTE_SD			0xFB
#define		NANM_BYTE_SIMPLE_BROADCAST	0xFC
#define		NANM_BYTE_SOH			0x01
#define		NANM_BYTE_ACK			0x85
#define 	NANM_BYTE_NAK			0x15

#define		NANM_MASTER_ID			0xF0
#define 	NANM_BROADCAST_ID		0xFF
#define		NANM_LAST_SLAVE_ID		0xEF

#define 	NANM_RESET_DELAY		2000 /* ms */

typedef unsigned char NANMId;

enum NANMCommandT {
    NANM_COMMAND_INITIALIZE = 0x01,
    NANM_COMMAND_SET_TIMENODE,
    NANM_COMMAND_REQUEST,
    NANM_COMMAND_SET_DELAY,
    NANM_COMMAND_SET_FREQUENCY_LIMIT,
    NANM_COMMAND_SET_MASTER,
    MANM_COMMAND_SET_HIGH_VOLTAGE,
    NANM_COMMAND_GET_HIGH_VOLTAGE,
    NANM_COMMAND_HIGH_VOLTAGE_ON,
    NANM_COMMAND_HIGH_VOLTAGE_OFF,
    NANM_COMMAND_BROADCAST,
    NANM_COMMAND_RESERVED,
    NANM_COMMAND_RESET,
    NANM_COMMAND_SET_ID,
    NANM_COMMAND_SOFTWARE_RESET
};
typedef enum NANMCommandT NANMCommand;

struct NANMDeviceT {
    DeviceS device;

    DSTime curtime;

    unsigned char hosts;
    unsigned char host[255];

    DSTime datatime;
    unsigned int rt_time;			/* Readout duration in ms */
    
    DeviceWriter dw;
    DeviceWriter triggerdw;
    
    unsigned char max_host;
    unsigned char reset;
};

typedef struct NANMDeviceT NANMDeviceS;
typedef struct NANMDeviceT *NANMDevice;


Device nanmDeviceCreate(DSConfigContext config, DSConfigReference ref);



#endif /* _NANM_H */
