#ifndef _NANM_BUFFER_H
#define _NANM_BUFFER_H

#include "buffer.h"

#define NANM_BAD_VALUE		(uint16_t)-1

typedef uint32_t nanmTriggerCount[255];

struct nanmTriggerDataT {
    unsigned int triggers;
    uint16_t *trigger_time;
    nanmTriggerCount *trigger_count;
};
typedef struct nanmTriggerDataT nanmTriggerDataS;
typedef struct nanmTriggerDataT *nanmTriggerData;


struct NANMReaderBufT {
    ReaderBufS buf;
    
    WriterDataID ids;
    WriterDataID *id;
    uint32_t *value;

    unsigned int rt_time;

    nanmTriggerDataS trigger;
};
typedef struct NANMReaderBufT NANMReaderBufS;
typedef struct NANMReaderBufT *NANMReaderBuf;

NANMReaderBuf nanmBufferCreate(NANMDevice dev, unsigned char hosts, unsigned char *host);
int nanmBufferSet(NANMReaderBuf buffer, unsigned int rt_time);
int nanmBufferAdd(NANMReaderBuf buffer, unsigned char id, uint16_t value);
int nanmBufferRegister(NANMDevice dev, NANMReaderBuf rb);
void nanmBufferDestroy(NANMReaderBuf buffer);

int nanmBufferTriggerInit(nanmTriggerData trigger, unsigned int triggers);

#endif /* _NAMT_BUFFER_H */
