#ifndef _SEVAN_H
#define _SEVAN_H

#define SEVAN_VERSION 1

#include <dstime.h>
#include <dslock.h>

#include "device.h"

#define SEVAN_WEATHER_DATA_SIZE			3
#define SEVAN_RESET_DELAY			2000 /* ms */

typedef unsigned char SEVANId;

struct SEVANDeviceT {
    DeviceS device;

    DSLockContext lock;
    DSTime lasttime;
    DSDuration force_duration;
    
    int rcd_flags;
    unsigned long duration;
    unsigned int channels, sensors;
    double *channel, *control_data;
    
    DeviceWriter dw;
    
    unsigned char reset;
};

typedef struct SEVANDeviceT SEVANDeviceS;
typedef struct SEVANDeviceT *SEVANDevice;


Device sevanDeviceCreate(DSConfigContext config, DSConfigReference ref);

#endif /* _SEVAN_H */
