#ifndef _XML_WRITER_H
#define _XML_WRITER_H

#include <dsxml.h>
#include "writer.h"

#define XML_WRITER_SUFFIX_HASH_SIZE		50

struct XMLWriterT {
    WriterS writer;
    
    char *path;
    char *descpath;
};

typedef struct XMLWriterT XMLWriterS;
typedef struct XMLWriterT *XMLWriter;

struct XMLWriterSuffixConfigT {
    char *suffix;

    char *layoutid;
};
typedef struct XMLWriterSuffixConfigT *XMLWriterSuffixConfig;
typedef struct XMLWriterSuffixConfigT XMLWriterSuffixConfigS;

struct XMLWriterInstanceT {
    WriterInstanceS instance;

    char *suffix;
        
    char *layoutid;
    char *configid;
    
    xmlDocPtr doc;
    xmlXPathContextPtr xp;
    xmlNodePtr layout;
    unsigned short int pos;

    xmlDocPtr data;
    xmlNodePtr data_node;
    xmlBufferPtr data_buf;

    FILE *f;

    DSHashTable sufconfigs;
    XMLWriterSuffixConfig sufcfg;
    unsigned char fixed_config;

#ifdef _XML_WRITER_C
    xmlXPathObjectPtr channel_type_obj;
    xmlXPathObjectPtr default_channel_type_obj;
#else
    void *channel_type_obj;
    void *default_channel_type_obj;
#endif /* _XML_WRITER_C */
};
typedef struct XMLWriterInstanceT XMLWriterInstanceS;
typedef struct XMLWriterInstanceT *XMLWriterInstance;

Writer XMLWriterCreate(xmlNodePtr cfg);

#endif /* _XML_WRITER_H */

