#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/time.h>

#define ADJUSTMENT1 10
#define ADJUSTMENT2 1
#define DIVIDER	50

#include "mb91364.h"

static void Signal(int signo) {
    int i;

    for (i=0;i<DIVIDER;i++) ihTimer16();

    for (i=0;i<ADJUSTMENT1;i++) {
	if (rand()%2) PDRR1 = 1<<rand() / (1 + (RAND_MAX / 6));
	else PDRR1 = rand() / (1 + (RAND_MAX / 128));
	if (rand()%2) PDRR2 = 1<<rand() / (1 + (RAND_MAX / 6));
	else PDRR2 = rand() / (1 + (RAND_MAX / 128));
	ExtInt0();
    }
    for (i=0;i<ADJUSTMENT2;i++) {
	PDRR1 = rand() / (1 + (RAND_MAX / 128));
	PDRR2 = rand() / (1 + (RAND_MAX / 128));
	ExtInt1();
    }
}

void Init() {
    struct itimerval tm;
    struct sigaction act;
    sigset_t set;
    
    act.sa_sigaction = NULL;
    act.sa_handler = Signal;
    sigfillset(&act.sa_mask);
    act.sa_flags = 0;

    sigaction(SIGALRM,&act,NULL);
    
    tm.it_interval.tv_sec = 0;
    tm.it_interval.tv_usec = 1000 * DIVIDER;
    tm.it_value.tv_sec = 0;
    tm.it_value.tv_usec = 1000 * DIVIDER;
    
    setitimer(ITIMER_REAL, &tm, NULL);

}
