#ifndef _DETECTOR_H
#define _DETECTOR_H

#include "config.h"

typedef struct DetectorDataT *DetectorData;
struct DetectorDataT {
    unsigned char detectors_number;
    DataType detectors1[MAX_DETECTORS_NUMBER];
    DataType detectors2[MAX_DETECTORS_NUMBER];
    DataType coincidences[MAX_DETECTORS_NUMBER*MAX_DETECTORS_NUMBER];
    DataType  many_many;
    DataType  many_zero;
    DataType  zero_many;
    DataType  zero_one;
    DataType  one_zero;
    DataType  many_one;
    DataType  one_many;
    DataType  total;
};

int ddInitDetector(DetectorData dd, unsigned char detectors_number);
void ddFreeDetector(DetectorData dd);
void ddResetData(DetectorData dd);

int ddSendData(DetectorData dd);
int ddSendCurrentData(DetectorData dd);
int ddSendCoincidenceData(DetectorData dd);
int ddSendCurrentCoincidenceData(DetectorData dd);

#ifdef _MAIN_C
static void ddHandleEvent(DetectorData dd, unsigned char data1, unsigned char data2) {
    int i;
    signed char x=-1, y=-1;

    for (i=dd->detectors_number-1;i>=0;i--) {	
	if (data1&bit(i)) {
	    dd->detectors1[i]++;
	    if (data1==bit(i)) x=i+1;
	    else x=0;
	}
	if (data2&bit(i)) {
	    dd->detectors2[i]++;
	    if (data2==bit(i)) y=i+1;
	    else y=0;
	}
    }
    
    if ((x>0)&&(y>0)) dd->coincidences[(x-1)*6+(y-1)]++;
    else if ((!x)&&(!y)) dd->many_many++;
    else if ((!x)&&(y<0)) dd->many_zero++;
    else if ((x<0)&&(!y)) dd->zero_many++;
    else if ((x<0)&&(y>0)) dd->zero_one++;
    else if ((x>0)&&(y<0)) dd->one_zero++;
    else if ((!x)&&(y>0)) dd->many_one++;
    else if ((x>0)&&(!y)) dd->one_many++;
    
    dd->total++;    
}

#pragma inline ddHandleEvent

#endif /* _MAIN_C */

#endif /* _DETECTOR_H */
