/* THIS SAMPLE CODE IS PROVIDED AS IS AND IS SUBJECT TO ALTERATIONS. FUJITSU */
/* MICROELECTRONICS ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR */
/* ELIGIBILITY FOR ANY PURPOSES.                                             */
/*                 (C) Fujitsu Microelectronics Europe GmbH                  */
;*******************************************************
;       Definition of Interrupt Vectors
;       (MB91F364 Architecture)
;*******************************************************

;		Three steps to define Interrupt-Vectors :
;		=========================================
;
;		1. Create an interrupt service routine (ISR) 
;		   in a C-module which looks like this :
;			void __interrupt ihTimer16(void) { ... }
;
;		2. Insert the ISR-name (with underscore) in this 
;		   file ("Import ISR Names") like this :
;	       .import _ihTimer16	
;
;		3. Locate the appropriate interrupt vector below
;		   and replace the "uninitial_int" with your ISR :
;	   		.ORG 	 0x0FFF9C		; reload timer #0
;      		.DATA	 _ihTimer16	

;*******************************************************

;	Import ISR Names :

		.import _ExtInt0
		.import _ExtInt1
		.import _ihTimer16
		.import _ihTriggerTimer16
           
;*******************************************************


        .SECTION        INTVECT,const,locate=0x0FFC00
        .GLOBAL         _vectors


_vectors:


	   .ORG 	 0x0FFEF4		; secvec
        .DATA	 0xFFFFFFFF

	   .ORG 	 0x0FFFBC		; ext. interrupt #0
        .DATA	 _ExtInt0

	   .ORG 	 0x0FFFB8		; ext. interrupt #1
        .DATA	 _ExtInt1

	   .ORG 	 0x0FFFB4		; ext. interrupt #2
        .DATA	 uninitial_int

	   .ORG 	 0x0FFFB0		; ext. interrupt #3
        .DATA	 uninitial_int

	   .ORG 	 0x0FFFAC		; ext. interrupt #4
        .DATA	 uninitial_int

	   .ORG 	 0x0FFFA8		; ext. interrupt #5
        .DATA	 uninitial_int

	   .ORG 	 0x0FFFA4		; ext. interrupt #6
        .DATA	 uninitial_int

	   .ORG 	 0x0FFFA0		; ext. interrupt #7
        .DATA	 uninitial_int

	   .ORG 	 0x0FFF9C		; reload timer #0
       .DATA	 _ihTimer16

	   .ORG 	 0x0FFF98		; reload timer #1
        .DATA	 _ihTriggerTimer16

	   .ORG 	 0x0FFF94		; reload timer #2
        .DATA	 uninitial_int
			
		

	   .ORG 	 0x0FFF90		; CAN0 RX
        .DATA	 uninitial_int

	   .ORG 	 0x0FFF8C		; CAN0 TX/NS
        .DATA	 uninitial_int



	   .ORG 	 0x0FFF70		; PPG 0/1
        .DATA	 uninitial_int

	   .ORG 	 0x0FFF6C		; PPG 2/3
        .DATA	 uninitial_int



	   .ORG 	 0x0FFF54		; ICU 0/1
        .DATA	 uninitial_int

	   .ORG 	 0x0FFF50		; OCU 0/1
        .DATA	 uninitial_int

	   .ORG 	 0x0FFF4C		; ICU 2/3
        .DATA	 uninitial_int

	   .ORG 	 0x0FFF48		; OCU 2/3
        .DATA	 uninitial_int

	   .ORG 	 0x0FFF44		; ADC
        .DATA    uninitial_int
        
	   .ORG 	 0x0FFF40		; Timebase Timer overflow
        .DATA	 uninitial_int

	   .ORG 	 0x0FFF3C		; free run cnt #0
        .DATA	 uninitial_int

	   .ORG 	 0x0FFF38		; free run cnt #1
        .DATA	 uninitial_int

	   .ORG 	 0x0FFF34		; SIO 0
        .DATA	 uninitial_int


	   .ORG 	 0x0FFF28		; UART0 RX
        .DATA	 uninitial_int

	   .ORG 	 0x0FFF24		; UART0 TX
        .DATA	 uninitial_int

	   .ORG 	 0x0FFF20		; LIN UART0 RX
        .DATA	 uninitial_int

	   .ORG 	 0x0FFF1C		; LIN UART0 TX
        .DATA	 uninitial_int

	   .ORG 	 0x0FFF18		; LIN UART1 RX
        .DATA	 uninitial_int

	   .ORG 	 0x0FFF14		; LIN UART1 TX
        .DATA	 uninitial_int

	   .ORG 	 0x0FFF10		; I2C
        .DATA	 uninitial_int

	   .ORG 	 0x0FFF08		; Real Time Clock
        .DATA	 uninitial_int

	   .ORG 	 0x0FFF00		; delayed interrupt
        .DATA	 uninitial_int

	   .ORG 	 0x0FFEBC		; Software INTs...
        .DATA	 uninitial_int


;*******************************************************

