#ifndef _COMMANDS_H
#define _COMMANDS_H

#define COMMAND_REQUEST_INFO			0x01
#define COMMAND_RESPONSE_INFO			0x01
#define COMMAND_REQUEST_RESET			0x02
#define COMMAND_RESPONSE_RESET			0x02
#define COMMAND_REQUEST_WATCHDOG		0x03
#define COMMAND_RESPONSE_WATCHDOG		0x03
#define COMMAND_REQUEST_ERRORS			0x04
#define COMMAND_RESPONSE_ERRORS			0x04
#define COMMAND_REQUEST_PING			0x05
#define COMMAND_RESPONSE_PING			0x05

    /* Support for this block may be droped or revised in future versions */
#define COMMAND_REQUEST_CALIBRATION_START	0x10
#define COMMAND_RESPONSE_CALIBRATION_START	0x10
#define COMMAND_REQUEST_CALIBRATION_FINISH	0x11
#define COMMAND_RESPONSE_CALIBRATION_FINISH	0x11
#define COMMAND_REQUEST_CALIBRATION		0x12
#define COMMAND_RESPONSE_CALIBRATION		0x12
#define COMMAND_REQUEST_SET_TIMER_CLOCK		0x13
#define COMMAND_RESPONSE_SET_TIMER_CLOCK	0x13
#define COMMAND_REQUEST_CORRECT_TIMER_CLOCK	0x14
#define COMMAND_RESPONSE_CORRECT_TIMER_CLOCK	0x14

#define COMMAND_REQUEST_PREPARE_SYNC		0x20
#define COMMAND_RESPONSE_PREPARE_SYNC		0x20
#define COMMAND_REQUEST_SYNC			0x21
#define COMMAND_RESPONSE_SYNC			0x21
#define COMMAND_REQUEST_GET_SYNC		0x22
#define COMMAND_RESPONSE_GET_SYNC		0x22
#define COMMAND_REQUEST_SET_SYNC		0x23
#define COMMAND_RESPONSE_SET_SYNC		0x23

#define COMMAND_REQUEST_SET_COUNTING_DURATION	0x31
#define COMMAND_RESPONSE_SET_COUNTING_DURATION	0x31
#define COMMAND_REQUEST_SET_TRIGGER_DURATION	0x33
#define COMMAND_RESPONSE_SET_TRIGGER_DURATION	0x33
#define COMMAND_REQUEST_SET_DA_VOLTAGE		0x34
#define COMMAND_RESPONSE_SET_DA_VOLTAGE		0x34
#define COMMAND_REQUEST_SET_SYNC_DIVIDER	0x35
#define COMMAND_RESPONSE_SET_SYNC_DIVIDER	0x35
#define COMMAND_REQUEST_SET_HV			0x36
#define COMMAND_RESPONSE_SET_HV			0x36
#define COMMAND_REQUEST_GET_HV			0x37
#define COMMAND_RESPONSE_GET_HV			0x37
#define COMMAND_REQUEST_SET_THRESHOLD		0x38
#define COMMAND_RESPONSE_SET_THRESHOLD		0x38
#define COMMAND_REQUEST_GET_THRESHOLD		0x39
#define COMMAND_RESPONSE_GET_THRESHOLD		0x39
#define COMMAND_REQUEST_RESET_FPGA		0x3A
#define COMMAND_RESPONSE_RESET_FPGA		0x3A
#define COMMAND_REQUEST_SPECTRUM_CONFIGURE_OUTPUT	0x3B
#define COMMAND_RESPONSE_SPECTRUM_CONFIGURE_OUTPUT	0x3B
#define COMMAND_REQUEST_SPECTRUM_RESET			0x3C
#define COMMAND_RESPONSE_SPECTRUM_RESET			0x3C
#define COMMAND_REQUEST_SET_SOFTWARE_THRESHOLD		0x3D
#define COMMAND_RESPONSE_SET_SOFTWARE_THRESHOLD		0x3D
#define COMMAND_REQUEST_CONFIGURE_EVENTS		0x3E
#define COMMAND_RESPONSE_CONFIGURE_EVENTS		0x3E
#define COMMAND_REQUEST_CONTROL				0x3F
#define COMMAND_RESPONSE_CONTROL			0x3F

#define COMMAND_REQUEST_GET			0x40
#define COMMAND_RESPONSE_GET			0x40
#define COMMAND_REQUEST_GET_COINCIDENCE		0x41
#define COMMAND_RESPONSE_GET_COINCIDENCE	0x41
#define COMMAND_REQUEST_GET_CURRENT		0x42
#define COMMAND_RESPONSE_GET_CURRENT		0x42
#define COMMAND_REQUEST_GET_CURRENT		0x42
#define COMMAND_RESPONSE_GET_CURRENT		0x42
#define COMMAND_REQUEST_GET_CURRENT_COINCIDENCE	0x43
#define COMMAND_RESPONSE_GET_CURRENT_COINCIDENCE 0x43
#define COMMAND_REQUEST_GET_SPECTRUM		0x44
#define COMMAND_RESPONSE_GET_SPECTRUM		0x44
#define COMMAND_REQUEST_GET_EVENTS		0x45
#define COMMAND_RESPONSE_GET_EVENTS		0x45


#define COMMAND_REQUEST_LAYOUT_INFO			0x50
#define COMMAND_RESPONSE_LAYOUT_INFO			0x50
#define COMMAND_REQUEST_LAYOUT_RESET			0x51
#define COMMAND_RESPONSE_LAYOUT_RESET			0x51
#define COMMAND_REQUEST_LAYOUT_USED_DETECTORS		0x52
#define COMMAND_RESPONSE_LAYOUT_USED_DETECTORS		0x52
#define COMMAND_REQUEST_LAYOUT_REGISTER_RULESET		0x53
#define COMMAND_RESPONSE_LAYOUT_REGISTER_RULESET	0x53
#define COMMAND_REQUEST_LAYOUT_REGISTER_RULE		0x54
#define COMMAND_RESPONSE_LAYOUT_REGISTER_RULE		0x54
#define COMMAND_REQUEST_LAYOUT_REGISTER_RULESPEC	0x55
#define COMMAND_RESPONSE_LAYOUT_REGISTER_RULESPEC	0x55


#define COMMAND_RESPONSE_ERROR			0xFF
#define COMMAND_RESPONSE_RETRY			0xFE

#define COMMAND_ERROR_UNKNOWN				0xFF
#define COMMAND_ERROR_FATAL				0xFE
#define COMMAND_ERROR_SOFTWARE				0xFD
#define COMMAND_ERROR_SOFTWARE_FATAL			0xFC

#define COMMAND_ERROR_INVALID_REQUEST			0x01
#define COMMAND_ERROR_NOT_SUPPORTED			0x02
#define COMMAND_ERROR_INVALID_PARAMETER			0x03
#define COMMAND_ERROR_INVALID_INSTALLATION_ID		0x04
#define COMMAND_ERROR_NO_DATA				0x05
#define COMMAND_ERROR_NOT_INITIALIZED			0x06
#define COMMAND_ERROR_EXCHANGE_TIME_IS_OVER		0x07
#define COMMAND_ERROR_NOT_ENOUGH_TIME			0x08
#define COMMAND_ERROR_UART				0x09
#define COMMAND_ERROR_CONTROL_RS485			0x0A

#define COMMAND_ERROR_SYNC				0x20

int COMMANDprocess(int input, unsigned short int cmd);

#endif /* _COMMANDS_H */
