#ifndef _DEFS_H
#define _DEFS_H

#include "config.h"

//#define InitializeEEPROM

#if defined(BUILD_SNT)
# define LADCboards		1
#else /* defined(BUILD_SNT) */
# define LADCboards		2
#endif /* defined(BUILD_SNT) */
#define LADCcpb			8

#define LADCchannels    	(LADCboards * LADCcpb)
#if LADCchannels < MAX_SENSORS_NUMBER
# error "Number of used channels greater than number of available channels (Check LADCchannels and MAX_DETECTORS_NUMBER)."
#endif

#ifdef _LADC_C
const unsigned char LADC_BOARD_NUMBER[LADCboards] = {
#if defined(BUILD_SNT)
    0
#else /* defined(BUILD_SNT) */
    3, 0
#endif /* defined(BUILD_SNT) */
};
#endif /* _LADC_C */

#define EEPROM			0
#define E_Thresholds		(EEPROM + 0)	/* size 8 */
#define FRAM_Chip		10
#define FRAM_Select		19

#define MCU_CHIP 		LPC213x
#define LPC213x			1
#define LPC214x			2

#define IO0PIN	IOPIN0
#define IO0SET	IOSET0
#define IO0DIR	IODIR0
#define IO0CLR	IOCLR0
#define IO1PIN	IOPIN1
#define IO1SET	IOSET1
#define IO1DIR	IODIR1
#define IO1CLR	IOCLR1

#define FALSE 	0
#define TRUE 	1
#define BOOL 	char
#define U8 	unsigned char
#define U16 	unsigned short int
#define U32 	unsigned long int

#define Bit(s)		(1 << s)
#define Bits(d,s)	(d << s)

#define EINT1bit    	Bit(15)
#define BODbit      	Bit(20)
#endif /* _DEFS_H */
