#ifndef _DETECTOR_H
#define _DETECTOR_H

#include "config.h"

typedef struct DetectorDataT *DetectorData;
typedef struct DetectorDataT DetectorDataS;

typedef struct DetectorEventT *DetectorEvent;
typedef struct DetectorEventT DetectorEventS;

struct DetectorEventT {
    unsigned long iter;
    unsigned long us;
    unsigned char detectors[2 * MAX_DETECTORS_NUMBER];
};

struct DetectorDataT {
    unsigned char detectors_number;
    DataType detectors1[MAX_DETECTORS_NUMBER];
    DataType detectors2[MAX_DETECTORS_NUMBER];
    DataType coincidences[MAX_DETECTORS_NUMBER*MAX_DETECTORS_NUMBER];
    DataType  many_many;
    DataType  many_zero;
    DataType  zero_many;
    DataType  zero_one;
    DataType  one_zero;
    DataType  many_one;
    DataType  one_many;
    DataType  total;
};

void DETECTORsetup();
int ddInitDetector(DetectorData dd, unsigned char detectors_number);
void ddFreeDetector(DetectorData dd);
void ddResetData(DetectorData dd);

int ddHandleEvent(DetectorData dd, unsigned long event_time, unsigned char *data);

int ddSendData(int input, DetectorData dd);
int ddSendCurrentData(int input, DetectorData dd);
int ddSendCoincidenceData(int input, DetectorData dd);
int ddSendCurrentCoincidenceData(int input, DetectorData dd);
int ddSendSpectrum(int input, DetectorData dd);
int ddSendEvents(int input, DetectorData dd);

#ifndef _DETECTOR_C
extern DetectorDataS dd11, dd12;
extern DetectorData dd1, ddp1, ddt1;
extern uint16_t thresholds[MAX_DETECTORS_NUMBER*2];
extern uint16_t software_thresholds[MAX_DETECTORS_NUMBER*2];

extern uint32_t handled_events;
extern unsigned char store_events;
extern unsigned short mmevents;
extern DetectorEventS mmevent[EVENT_BUFFER_SIZE + 1];

extern uint16_t thresholds[MAX_DETECTORS_NUMBER*2];
#endif /* _DETECTOR_C */

#define DETECTORswitch() \
    ddt1=dd1; dd1=ddp1; ddp1=ddt1;

#endif /* _DETECTOR_H */
