#ifndef _DETECTOR_H
#define _DETECTOR_H

#include "config.h"

typedef struct DetectorDataT *DetectorData;
typedef struct DetectorDataT DetectorDataS;

typedef struct DetectorEventT *DetectorEvent;
typedef struct DetectorEventT DetectorEventS;


struct DetectorEventT {
    unsigned long iter;
    unsigned long us;
    unsigned char detectors[MAX_DETECTORS_NUMBER];
};


struct DetectorDataT {
    DataType detectors[MAX_DETECTORS_NUMBER];
    DataType coincidences[MAX_RULESETS];
    DataType total;
};

void DETECTORsetup();
int ddInitDetector(DetectorData dd, unsigned char detectors_number);
void ddFreeDetector(DetectorData dd);
void ddResetData(DetectorData dd);

int ddHandleEvent(DetectorData dd, unsigned long event_time, unsigned char *data);

int ddSendData(int input, DetectorData dd);
int ddSendCurrentData(int input, DetectorData dd);
int ddSendCoincidenceData(int input, DetectorData dd);
int ddSendCurrentCoincidenceData(int input, DetectorData dd);
int ddSendSpectrum(int input, DetectorData dd);
int ddSendEvents(int input, DetectorData dd);

#define DETECTORswitch() \
    ddt1=dd1; dd1=ddp1; ddp1=ddt1;

#endif /* _DETECTOR_H */
