#include <irq.h>

#define _LADC_C

#include "time.h"
#include "spi.h"
#include "i2c.h"
#include "ladc.h"
#include "spi.h"


#define GATE            Bit(7)
#define DUR_OUT         Bit(30)
#define SEL0            Bit(10)
#define SEL1            Bit(11)
#define SEL2            Bit(28)
#define SEL3            Bit(29)
#define CS0 	        Bit(18)
#if MCU_CHIP == LPC214x
# define CS1		Bit(22)
#else
# define CS1		Bit(31)
#endif
#define INTA            Bit(13)
#define LOAD_THRESHOLDS Bit(14)                         
#define _GATE_IRQ_

const U32 LADC_BoardSelMask = CS1 | CS0;

const U32 LADC_BoardSel[] = {
  CS1 | CS0,
  CS1 |   0,
    0 | CS0,
    0 |   0,
};

const U32 ADC_SelMask = CS1 | CS0 | SEL3 | SEL2 | SEL1 | SEL0;

const U32 ADC_Sel[] = {
  CS1  | CS0  |    0 |    0 |    0 |    0,
  CS1  | CS0  |    0 |    0 |    0 | SEL0,
  CS1  | CS0  |    0 |    0 | SEL1 |    0,
  CS1  | CS0  |    0 |    0 | SEL1 | SEL0,
  CS1  | CS0  |    0 | SEL2 |    0 |    0,
  CS1  | CS0  |    0 | SEL2 |    0 | SEL0,
  CS1  | CS0  |    0 | SEL2 | SEL1 |    0,
  CS1  | CS0  |    0 | SEL2 | SEL1 | SEL0,
  CS1  | CS0  | SEL3 |    0 |    0 |    0,
  CS1  | CS0  | SEL3 |    0 |    0 | SEL0,
  CS1  | CS0  | SEL3 |    0 | SEL1 |    0,
  CS1  | CS0  | SEL3 |    0 | SEL1 | SEL0,
  CS1  | CS0  | SEL3 | SEL2 |    0 |    0,
  CS1  | CS0  | SEL3 | SEL2 |    0 | SEL0,
  CS1  | CS0  | SEL3 | SEL2 | SEL1 |    0,
  CS1  | CS0  | SEL3 | SEL2 | SEL1 | SEL0,

  CS1  |    0 |    0 |    0 |    0 |    0,
  CS1  |    0 |    0 |    0 |    0 | SEL0,
  CS1  |    0 |    0 |    0 | SEL1 |    0,
  CS1  |    0 |    0 |    0 | SEL1 | SEL0,
  CS1  |    0 |    0 | SEL2 |    0 |    0,
  CS1  |    0 |    0 | SEL2 |    0 | SEL0,
  CS1  |    0 |    0 | SEL2 | SEL1 |    0,
  CS1  |    0 |    0 | SEL2 | SEL1 | SEL0,
  CS1  |    0 | SEL3 |    0 |    0 |    0,
  CS1  |    0 | SEL3 |    0 |    0 | SEL0,
  CS1  |    0 | SEL3 |    0 | SEL1 |    0,
  CS1  |    0 | SEL3 |    0 | SEL1 | SEL0,
  CS1  |    0 | SEL3 | SEL2 |    0 |    0,
  CS1  |    0 | SEL3 | SEL2 |    0 | SEL0,
  CS1  |    0 | SEL3 | SEL2 | SEL1 |    0,
  CS1  |    0 | SEL3 | SEL2 | SEL1 | SEL0,

     0 | CS0  |    0 |    0 |    0 |    0,
     0 | CS0  |    0 |    0 |    0 | SEL0,
     0 | CS0  |    0 |    0 | SEL1 |    0,
     0 | CS0  |    0 |    0 | SEL1 | SEL0,
     0 | CS0  |    0 | SEL2 |    0 |    0,
     0 | CS0  |    0 | SEL2 |    0 | SEL0,
     0 | CS0  |    0 | SEL2 | SEL1 |    0,
     0 | CS0  |    0 | SEL2 | SEL1 | SEL0,
     0 | CS0  | SEL3 |    0 |    0 |    0,
     0 | CS0  | SEL3 |    0 |    0 | SEL0,
     0 | CS0  | SEL3 |    0 | SEL1 |    0,
     0 | CS0  | SEL3 |    0 | SEL1 | SEL0,
     0 | CS0  | SEL3 | SEL2 |    0 |    0,
     0 | CS0  | SEL3 | SEL2 |    0 | SEL0,
     0 | CS0  | SEL3 | SEL2 | SEL1 |    0,
     0 | CS0  | SEL3 | SEL2 | SEL1 | SEL0,

     0 |    0 |    0 |    0 |    0 |    0,
     0 |    0 |    0 |    0 |    0 | SEL0,
     0 |    0 |    0 |    0 | SEL1 |    0,
     0 |    0 |    0 |    0 | SEL1 | SEL0,
     0 |    0 |    0 | SEL2 |    0 |    0,
     0 |    0 |    0 | SEL2 |    0 | SEL0,
     0 |    0 |    0 | SEL2 | SEL1 |    0,
     0 |    0 |    0 | SEL2 | SEL1 | SEL0,
     0 |    0 | SEL3 |    0 |    0 |    0,
     0 |    0 | SEL3 |    0 |    0 | SEL0,
     0 |    0 | SEL3 |    0 | SEL1 |    0,
     0 |    0 | SEL3 |    0 | SEL1 | SEL0,
     0 |    0 | SEL3 | SEL2 |    0 |    0,
     0 |    0 | SEL3 | SEL2 |    0 | SEL0,
     0 |    0 | SEL3 | SEL2 | SEL1 |    0,
     0 |    0 | SEL3 | SEL2 | SEL1 | SEL0
};

static void EventHandler (void) __irq;

void LADCsetup() {
    IO0SET = LOAD_THRESHOLDS;
    IO0DIR |= ADC_SelMask | RESET_LADC | LOAD_THRESHOLDS | INTA;

    IO0SET = RESET_LADC;
    TIMEdelay(1);
    IO0CLR = RESET_LADC;
}

void LADCenableIRQ() {
    IO0SET = INTA;
    IO0SET = INTA;
    IO0CLR = INTA;
    IO0CLR = INTA;
    
    EXTINT = EINT2;
}

void LADCresetBoard() {
    IO0SET = RESET_LADC;
    TIMEdelay(1);
    IO0CLR = RESET_LADC;
}

void LADCsetupIRQ() {
#ifdef _GATE_IRQ_
    PINSEL0 |= Bits(0x3, 14); // Select for the Pin 31 (P0.7) EINT2 interruption input
    install_irq(EINT2_INT, (void*)EventHandler);
#else /* _GATE_IRQ_ */
    PINSEL1 |= Bits(0x2, 28); // Select for the Pin 15 (P0.30) EINT3 interruption input
    install_irq(EINT3_INT, EventHandler);
    EXTINT = EINT3;
#endif /* _GATE_IRQ_ */

    LADCresetBoard();
    LADCenableIRQ();
}

void SelectLADC_Board(U8 LADCnum)
{
    IO0CLR = LADC_BoardSelMask;
    IO0SET = LADC_BoardSel[LADC_BOARD_NUMBER[LADCnum] & 3];

    TIMEdelay(1);	// By S.C.
}

U8 ReadLADC(U8 selector)
{
  IO0CLR = ADC_SelMask;
  IO0SET = ADC_Sel[selector & 0x3F];

  return IO1PIN >> 16;
}

// TLV5628 DAC Support

void WriteDAC(U8 channel, U8 data)
{
  U32 DefDivider;

  SelectLADC_Board(channel/8);    // Connect LDAC to LOAD_THRESHOLDS 

  DefDivider = S0SPCCR;
  S0SPCCR = 120;            	// 500kHz

  SPI0((7-(channel % 8)) << 1);
  SPI0(data);

  IO0CLR = LOAD_THRESHOLDS;
  TIMEdelay(1);
  IO0SET = LOAD_THRESHOLDS;

  S0SPCCR = DefDivider;
}

U8 Threshold[] = {
  252, 252, 252, 252, 252, 252, 252, 252,
  252, 252, 252, 252, 252, 252, 252, 252,
  252, 252, 252, 252, 252, 252, 252, 252,
  252, 252, 252, 252, 252, 252, 252, 252
};

void InitDAC()
{
  U16 i;

  for (i = 0; i < LADCchannels; i++) {
#ifdef  InitializeEEPROM
    WriteEEPROM(E_Thresholds + i, Threshold[i]);
#else
    Threshold[i] = ReadEEPROM(E_Thresholds + i);
#endif
    WriteDAC(i, Threshold[i]);
  }
}

unsigned char irq_disabled = 0;
unsigned char Event1 = 0, Overload1 = 0;
unsigned char Data1[BUFFER_SIZE][LADCchannels];
unsigned long EventTime1[BUFFER_SIZE];
unsigned int buffer1_start=0, buffer1_end=0, buffer1_new_iteration=0;

static void EventHandler (void) {
    int i;
    unsigned char channel, board;
    unsigned char event[LADCboards], cevent;
    unsigned short int pulses;

    unsigned long event_time;


    event_time = T0TC;
    if (rest_flag) event_time += 1000*(counting_duration + rest_counting_duration + sync_flag - mls);
    else event_time += 1000*(counting_duration - mls);

    IO0CLR = ADC_SelMask;
    IO0SET = ADC_Sel[8];    // Selectors 8..15 all select the same Profile

    for (board=0;board<LADCboards;board++) {
	SelectLADC_Board(board);
	event[board] = (IO1PIN >> 16)&0xFF;
    }
    
	    // Waiting event
    for (i=0;(!(IO0PIN & DUR_OUT)); i++) {
	if (i > 128) {
	    Overload1 = 1;
    	    goto Exit;
	}    
	TIMEdelay(1);
    }

  
	// Reading number of pulses
    for (board = 0; board < LADCboards; board++) {
	cevent = event[board];
	for (channel = 0; channel < LADCcpb; channel++) {

	    if (cevent & (1 << channel)) { 
		IO0CLR = ADC_SelMask;
		IO0SET = ADC_Sel[(LADC_BOARD_NUMBER[board]<<4)|channel];
		TIMEdelay(1);	// Some times zeroes without it
		
		pulses = 0xFF & (IO1PIN >> 16);
		if (pulses > 127) Data1[buffer1_end][board*LADCcpb+channel] = 127;
//	    	else if (!pulses) Data1[buffer1_end][board*LADCcpb+channel] = 1;
		else Data1[buffer1_end][board*LADCcpb+channel] = pulses;
	    } else {
		Data1[buffer1_end][board*LADCcpb+channel] = 0;
	    }
	}
    }


    EventTime1[buffer1_end] = event_time;

    if ((++buffer1_end)==BUFFER_SIZE) buffer1_end = 0;
    if (buffer1_end == buffer1_start) {
	Event1 = 1;
	goto Exit;	// Skipping Event. And dissabling until freeing buffer
    }

    IO0SET = INTA;
    IO0SET = INTA;
    IO0CLR = INTA;
    IO0CLR = INTA;

Exit:
    EXTINT = EINT2;		/* External Event Handled */

    VICVectAddr = 0;
}
