#ifndef _LAYOUT_H
#define _LAYOUT_H

void LAYOUTsetup();
void LAYOUTreset();
int LAYOUTsetDetectors(short detectors);
int LAYOUTregisterRuleSet(int input);
int LAYOUTregisterRule(int input);
int LAYOUTregisterRuleSpec(int input);

#include "config.h"

#ifdef HAVE_LAYOUT
typedef struct RuleT *Rule;
typedef struct RuleT RuleS;
typedef struct RuleSetT *RuleSet;
typedef struct RuleSetT RuleSetS;
typedef struct RuleSpectrumT *RuleSpectrum;
typedef struct RuleSpectrumT RuleSpectrumS;

struct RuleT {
    signed char source;		/* >0 - sensors, <0 - rulesets, 0 - not defined  */
    signed char threshold;	/*  
				    0	 TRIGGERED:
					above software threshold for sensors
					ruleok (success) for thresholds
				    -127 NOT TRIGGERED:
					below or equal software threshold
					not ruleok
				    >0 	 GREATER OR EQUAL THAN
				    <0 - LESS THAN 
				*/
};

struct RuleSetT {
    unsigned char config;	/* 
				    bit 0: 	Count
				    bit 1: 	Event
				    bit 2-7:	Number of Rules
				*/
    signed char success;	/* 
				    0	not defined
				    >0	minimal number of O'Keys (>=)
				    <0	maximal number of O'Keys (<)
				*/
    RuleS rule[MAX_RULES];	/* Rules */
};

struct RuleSpectrumT {
    unsigned short ruleset;	/* from 1 */
    unsigned short sensor;	/* from 1 */
};


# ifndef _LAYOUT_C
extern unsigned short rulesets;
extern RuleSetS ruleset[MAX_RULES];
extern unsigned short rulespecs;
extern RuleSpectrumS rulespec[MAX_SPECTRUMS];

extern unsigned short detectors_number;
extern unsigned short coincidences_number;
extern unsigned short spectrums_number;
# endif /* _LAYOUT_C */
#endif /* HAVE_LAYOUT */


#endif /* _LAYOUT_H */
