#ifndef _SERIAL_H
#define _SERIAL_H


void UARTsetup(unsigned long int baud1, unsigned long int baud2);
int sendchar (int ch);
int getkey (void);


int UARTreceived(int i);
int UART1received();
int UART2received();

int UARTgetch(int i);
int UARTgetchW(int i);
int UARTgetchDW(int i);

#define UART1getch() UARTgetch(1)
#define UART1getchW() UARTgetchW(1)
#define UART1getchDW() UARTgetchDW(1)
#define UART2getch() UARTgetch(2)
#define UART2getchW() UARTgetchW(2)
#define UART2getchDW() UARTgetchDW(2)

void UARTputch(int i, int ch);
void UARTputchW(int i, int ch);
void UARTputchDW(int i, int ch);

#define UART1putch(v) UARTputch(1,v)
#define UART1putchW(v) UARTputchW(1,v)
#define UART1putchDW(v) UARTputchDW(1,v)
#define UART2putch(v) UARTputch(2,v)
#define UART2putchW(v) UARTputchW(2,v)
#define UART2putchDW(v) UARTputchDW(2,v)

int UARTputs(int i, const char *str);
int UARTgets(int i, char *str, int size);
int UARTrequest(int i, const char *req, char *resp, int size);


int UARTskip(int i);
#define UART1skip() UARTskip(1)
#define UART2skip() UARTskip(2)

#endif /* _SERIAL_H */
