#include <irq.h>
#include "setup.h"

#include "serial.h"
#include "time.h"
#include "sync.h"
#include "watchdog.h"
#include "layout.h"
#include "detector.h"
#include "error.h"
#include "ladc.h"
#include "i2c.h"
#include "spi.h"
#include "spectrum.h"

/*
BOD interruption.
During EEPROM and FRAM write operations the BOD interruption is disabled, 
but immediatelly after writing it is enabled again. If the power falls slow 
enough, the EEPROM and FRAM will not be corrupted, even if switch the power 
off during the writing process.


void FIQ_Handler () __fiq {
    while (VICRawIntr & BODbit) WDfeed();
}
*/

void IRQinit() {
//    VICIntSelect   = BODbit;
//    VICIntEnable   = BODbit;		
}

int LPCsetup() {
//  VPBDIV = 1;	// Setting VPB Divider (Set Startup.S) 

    PINSEL0 = 0;
    PINSEL1 = 0;
    PINSEL2 = 0;

    init_VIC();		// Setting IRQ table
    IRQinit();		// Installing IRQ handlers

    UARTsetup(UART_SPEED, RS485_SPEED);

    TIMEsetup();

    SYNCsetup();
    WDsetup();

    InitFRAM();
    InitI2C();
    LADCsetup();
    InitDAC();

    LAYOUTsetup();
    DETECTORsetup();
    ERRORsetup();
    SPECTRUMsetup();

    LADCsetupIRQ();
        
    return 0;
}
