#include <stdio.h>  
#include <lpc214x.h>
#include <irq.h>

#define _SNT_C

#include "setup.h"
#include "serial.h"
#include "commands.h"
#include "watchdog.h"
#include "sync.h"
#include "time.h"
#include "detector.h"
#include "error.h"
#include "ladc.h"

void Process1Events(unsigned long maxevents) {
    int events = 0;
    
    while ((events<maxevents)&&((buffer1_start!=buffer1_end)||(Event1))) {
	WDfeed();
	if (Event1) {
	    ERRORregister(MCU_ERROR_BUFFER_FULL);
	    
	    if (buffer1_start!=buffer1_end) {
		Event1 = 0;
		LADCenableIRQ();
	    }
	}
	events += ddHandleEvent(dd1, EventTime1[buffer1_start], Data1[buffer1_start]);
	if ((++buffer1_start)==BUFFER_SIZE) buffer1_start=0;
	
/*	Impossible
	if ((buffer1_start == buffer1_new_iteration)&&(!Event1)) buffer1_new_iteration = 0;
*/
    }
}


int main (void)  {
    short int cmd;

    int input;

    LPCsetup();

    while (1) {
	WDfeed();

	if (Overload1) {
	    ERRORregister(MCU_ERROR_GATE_TOO_LONG);
	    Overload1 = 0;
	    irq_disabled = 1;
	}
	
	do {
	    Process1Events(-1);
	} while ((rest_flag)&&(mls<DEAD_COUNTING_DURATION));

	if (reset_flag) {
	    ddResetData(ddp1);
	    reset_flag = 0;
	}

	while ((input = UARTreceived(PC_CONNECTION))) {
	    cmd = UARTgetch(input);

	    COMMANDprocess(input, cmd);
	    if (SYNCcheck()) break;
	    WDfeed();
	}
	
	if (irq_disabled) {
	    LADCenableIRQ();
	    irq_disabled = 0;
	}
    }
}

