<?

function list_category($catname, $xpathreq, &$configured_voltages, $voltage_sub) {
    global $dev;
    
    $notfound = 1;

    $voltages = "<" . $catname . "s>";
    $detectors = list_filedetectors(TRUE);
    foreach ($detectors as $detector) {
	if (preg_match("/^$dev[name]/", $detector)) {
	    if (isset($voltage_sub))
		$data = xmldata($dev["name"], $detector, $voltage_sub);
	    else 
		$data = xmldata($dev["name"], $detector, FALSE);
	    
	    if ($data) {
		$data_xp = new DOMXPath($data);

		$res = $data_xp->query($xpathreq);
		foreach ($res as $channel) {
		    $layer = $channel->getAttribute('layer');
		    $sensor = $channel->getAttribute('sensor');
		    if (strlen($layer)) {
			$configured_voltages["$detector-$layer-$sensor"] = 1;
			$voltages .= "<" . $catname . " device=\"$detector\" layer=\"" . $layer . "\" sensor=\"" . $sensor . "\">" . $channel->nodeValue ."</" . $catname . ">";
			
			$notfound = 0;
		    } else if (strlen($sensor)) {
			$configured_voltages["$detector-1-$sensor"] = 1;
			$voltages .= "<" . $catname . " device=\"$detector\" layer=\"1\" sensor=\"" . $sensor . "\">" . $channel->nodeValue ."</" . $catname . ">";
		    
			$notfound = 0;
		    }
		    
		}
		
		unset($res);
		unset($data_xp);
		unset($data);
	    }
	} 
    }
    if ($notfound) {
	if (function_exists("config_list_category")) $voltages .= config_list_category($catname, &$configured_voltages);
    }
    $voltages .= "</" . $catname . "s>";

    return $voltages;
}

function page_head() {
    global $dev;
    global $voltage_sub;
    global $threshold_sub;
    global $configured_voltages;
    global $configured_thresholds;

    $configured_voltages = array();
    $configured_thresholds = array();
    
    $fp = popen("adas-simple -c /" . $dev["name"], "r");
    if ($fp) {
	while (!feof($fp)) {
	    $curcfg .= fgets($fp);
	}
	pclose($fp);
    } else return 1;
    
    $doc = new DOMDocument();
    $doc->loadXML($curcfg);

    $xpath = new DOMXPath($doc);

    $res = $xpath->query("/DeviceConfiguration");
    if ($res->length>0) $root = $res->item(0);
    else {
	$root = $doc->createElement("DeviceConfiguration");
	$doc->appendChild($root);
    }
    
    
    $res = $xpath->query("/DeviceConfiguration/Configuration");
    if ($res->length>0) {
	$cfgnode = $res->item(0);
	    // Removing trailing zeros in double values
	$res = $xpath->query("descendant::text()", $cfgnode);
	if ($res) {
	    foreach ($res as $node) {
		if ((preg_match("/^\s*(\d+\.\d*[1-9])0+\s*$/", $node->nodeValue, $m))|| 
		    (preg_match("/^\s*(\d+)\.0+\s*$/", $node->nodeValue, $m))) {
		    $node->parentNode->replaceChild(new DOMText($m[1]), $node);
		}
	    }
	}
    } else {
	$cfgnode = $doc->createElement("Configuration");
	$root->appendChild($cfgnode);
    }

    if (function_exists("config_adjust_configuration")) 
	config_adjust_configuration($cfgnode, $xpath);
    $configuration = $doc->saveXML($cfgnode);

    $res = $xpath->query("/DeviceConfiguration/Processor");
    if ($res->length>0) {
	$cfgnode = $res->item(0);
    } else {
	$cfgnode = $doc->createElement("Processor");
	$root->appendChild($cfgnode);
    }

    if (function_exists("config_adjust_processor")) 
	config_adjust_processor($cfgnode, $xpath);
    $processor = $doc->saveXML($cfgnode);

    $res = $xpath->query("/DeviceConfiguration/Layout");
    if ($res->length>0) {
	$cfgnode = $res->item(0);
    } else {
	$cfgnode = $doc->createElement("Layout");
	$root->appendChild($cfgnode);
    }

    if (function_exists("config_adjust_layout"))
	config_adjust_layout($cfgnode, $xpath);
    $layout = $doc->saveXML($cfgnode);

    unset($res);
    unset($xpath);
    unset($doc);

    if (isset($_GET['hv'])) {
	$voltages = list_category("Voltage", "//Channel[@type=\"voltage\"]", $configured_voltages, $voltage_sub);
	$thresholds = list_category("Threshold", "//Channel[@type=\"threshold\"]", $configured_thresholds, $threshold_sub);
    } else {
	$voltages="";
	$thresholds="";
    }
?>
    <link rel="stylesheet" type="text/css" href="adas-control.css"/>
    <script type="text/javascript" src="formfaces/formfaces.js"/>

    <xf:model id="configuration_model">
	<xf:instance>
	    <conf xmlns="" id="adjustconfig_conf" name="adjustconfig_conf"><?
		print($configuration);
		print($processor);
		print($layout);
		print($voltages);
		print($thresholds);
		if (function_exists("config_conf")) config_conf();
		?><Valid><?
		    if (function_exists("config_valid")) config_valid();
		?></Valid><?
		?><Selected><?
		    if (function_exists("config_selected")) config_selected();
		?></Selected><?
	    ?></conf>
	</xf:instance>
	<xf:bind nodeset="/conf/Valid" relevant="(count(/conf/Valid/*[text() = 1]) = count(/conf/Valid/*))<?
	    if (function_exists("config_valid_xpath")) config_valid_xpath();?>"/>
	<?
	if (function_exists("config_model")) config_model();
	?><xf:submission id="form" validate="true" method="post" replace="instance" action="adjustconfigdb.php?detector=<?echo $_GET["detector"];?>">
	    <?if (function_exists("config_submit_done")) config_submit_done();?>
	</xf:submission>
    </xf:model><?  
    if (function_exists("config_head")) config_head();
    return 0;
}


function page_body() {
    config_page();
}

function ac_place_submit($label) {
    ?><div class="submit_configuration">
      <xf:trigger ref="/conf/Valid">
	<xf:label><?echo $label;?></xf:label>
	<xf:action ev:event="DOMActivate"><?
    if (function_exists("config_submit_actions")) config_submit_actions();
	    ?><xf:send submission="form"/>
	</xf:action>
      </xf:trigger>
    </div><?
}

if (!$authenticated) {
    $error = $unauthorized;
} else {
    set_dev();
    
    if (isset($_GET['hv'])) {
      switch ($dev["type"]) {
	case "SEVAN":
	    require("sevanconfig.php");    
	break;
	case "NAMT":
	case "SA":
	    require("namtconfig.php");
	break;
	default:
	    $control_not_supported = 1;
      }
    } else if (isset($_GET['layout'])) {
      switch ($dev["type"]) {
        case "SA":
	    require("layoutconfig.php");
	break;
	default:
	    $control_not_supported = 1;
      }
    } else {
	$control_not_supported = 1;
    }
    
    if (!$error) {
	if ($control_not_supported) {
	    $error = "<span class=\"highlight\">Not Implemented!</span>";
	} else {
	    $sensors = parse_detector_info($dev, $subdevices);
	}
    }
}

?>