function graphShow(attr, graph, i) {
    if (attr.selected) {
	if ((attr.selected == i)&&(attr.selected_xslt)) {
	    var svgdata;
	    if ((attr.norm)&&(attr.norm_xslt))
		svgdata = attr.norm_xslt.transformToFragment(graph, document);
	    else 
		svgdata = attr.selected_xslt.transformToFragment(graph, document);

	    var graph_node = document.getElementById(attr.prefix + "-selected");
	    if (graph_node) {
		if (graph_node.firstChild) graph_node.replaceChild(svgdata, graph_node.firstChild);
		else graph_node.appendChild(svgdata);
	    }
	}
    } else {
	var svgdata = attr.xslt.transformToFragment(graph, document);

	var graph_node = document.getElementById(attr.prefix + "-" + i);
	if (graph_node) {
	    if (graph_node.firstChild) graph_node.replaceChild(svgdata, graph_node.firstChild);
	    else graph_node.appendChild(svgdata);
	}
    }
}


function graphNSResolver(prefix) {
  if(prefix == 'xhtml') {
    return 'http://www.w3.org/1999/xhtml';
  } else {
    return null;
  }
}

function graphHandler(xmldoc, attr) {
    var graph;    
    var res = xmldoc.evaluate("//Graph[@sid]", xmldoc, graphNSResolver, XPathResult.ANY_TYPE, null);

    graph = res.iterateNext();
    for (i=1;graph;i++) {
	graphShow(attr, graph, i);
	graph = res.iterateNext();
    }
}

function graphXSLT(xsltproc, attr) {
    attr.xslt = xsltproc;
}

function graphSelectedXSLT(xsltproc, attr) {
    attr.selected_xslt = xsltproc;
}

function graphNormXSLT(xsltproc, attr) {
    attr.norm_xslt = xsltproc;
}

function graphSetupRunner(attr) {
    if ((attr.xslt)&&(attr.selected_xslt)) valueRunner2(attr.xmlurl, attr.graphHandler, attr.prefix, attr.init_time, attr.renew_time, attr);
    else setTimeout(graphSetupRunner, 1000, attr);
}


function Graph(prefix, xslturl, xmlurl, init_time, renew_time) {
    if (arguments.length) this.setup(prefix, xslturl, xmlurl, init_time, renew_time);
}

Graph.prototype.setup = function(prefix, xslturl, xmlurl, init_time, renew_time) {
	this.name ="Graph";
	this.init_time = init_time;
	this.renew_time = renew_time;
	this.prefix = prefix;
	this.xmlurl = xmlurl;
	this.xslturl = xslturl;
	this.graphHandler = graphHandler;

	this.xslt = false;
	this.selected_xslt = false;
	this.norm_xslt = false;
	this.selected = 0;
	this.norm = 0;
}

Graph.prototype.start = function() {
	loadXSLT(this.xslturl, graphXSLT, this);
	loadXSLT(this.xslturl + "?selected", graphSelectedXSLT, this);
	setTimeout(graphSetupRunner, 1000, this);
}

function graphSetup(prefix, xslturl, xmlurl, init_time, renew_time) {
    var g = new Graph(prefix, xslturl, xmlurl, init_time, renew_time);
    g.start();

    return g;
}

function graphSetupNormalizer(attr) {
    loadXSLT(attr.xslturl + "?selected&normalize", graphNormXSLT, attr);
}

function graphSelect(attr, num, header) {
    if (num) {
	attr.selected = num;
	document.getElementById(attr.prefix + "-selected-div").style.display = "block";
	
	var idnode = document.getElementById(attr.prefix + "-selected-id")
	var prenode = document.getElementById(attr.prefix + "-selected-preid")
	var postnode = document.getElementById(attr.prefix + "-selected-postid")

	if (idnode) {
	    if (header) {
		if (prenode) prenode.style.display = "none";
		if (postnode) postnode.style.display = "none";
		nodeSetText(idnode, header);
	    } else {
		if (prenode) prenode.style.display = "inline";
		if (postnode) postnode.style.display = "inline";
		nodeSetText(idnode, num);
	    }
	}
    } else {
	attr.selected = 0;
	document.getElementById(attr.prefix + "-selected-div").style.display = "none";
	
	var graph_node = document.getElementById(attr.prefix + "-selected");
	if (graph_node) nodeSetText(graph_node, "Loading...");
    }

    loadXML(attr.xmlurl, attr.graphHandler, attr);
}

function graphNormalize(attr, num) {
    if (num < 0) {
	if (attr.norm) attr.norm = 0;
	else attr.norm = 1;
    } else attr.norm = num;

    loadXML(attr.xmlurl, attr.graphHandler, attr);
}
