<?

function config_adjust_layout(&$node, $xpath) {
    $res = $xpath->query("Coincidences", $node);
    if ($res->length > 0) $cnode = $res->item(0);
    else {
	$cnode = $node->ownerDocument->createElement("Coincidences");
	$node->appendChild($cnode);
    } 

    $res = $xpath->query("Spectrums", $node);
    if ($res->length > 0) $snode = $res->item(0);
    else {
	$snode = $node->ownerDocument->createElement("Spectrums");
	$node->appendChild($snode);
    } 

    $res = $xpath->query("descendant::RuleSet", $node);
    foreach ($res as $item) {
	if (!$item->hasAttribute("type")) {
	    $item->parentNode->removeChild($item);
	    continue;
	}
	if (!$item->hasAttribute("name")) {
	    $item->parentNode->removeChild($item);
	    continue;
	}

	if (!$item->hasAttribute("description")) {
	    $item->setAttribute("description", $item->getAttribute("name"));
	}


	if (!$item->hasAttribute("events")) {
	    $item->setAttribute("events", "");
	}

	if (!$item->hasAttribute("dummy")) {
	    $item->setAttribute("dummy", "");
	}

	if (!$item->hasAttribute("success")) {
	    if (preg_match("/(custom)/", $item->getAttribute("type"))) {
		$item->setAttribute("success", "above");
	    } else {
		$item->setAttribute("success", "");
	    }
	}

	if (!$item->hasAttribute("threshold")) {
	    $item->setAttribute("threshold", "0");
	}
    }

    $res = $xpath->query("descendant::Rule", $node);
    foreach ($res as $item) {
	if ((!$item->hasAttribute("type"))||(!$item->hasAttribute("target"))) {
	    $item->parentNode->removeChild($item);
	    continue;
	}

	if (!$item->hasAttribute("test")) {
	    $item->setAttribute("test", "true");
	}

	if (!$item->hasAttribute("threshold")) {
	    if (preg_match("/(above|below)/", $item->getAttribute("test"))) {
		$item->setAttribute("threshold", "0");
	    } else {
		$item->setAttribute("threshold", "");
	    }
	}
    }
    
    $res = $xpath->query("descendant::Spectrum", $node);
    foreach ($res as $item) {
	if ((!$item->hasAttribute("sensor"))||(!$item->hasAttribute("ruleset"))) {
	    $item->parentNode->removeChild($item);
	    continue;
	}
    }

	
    $fakenode = $node->ownerDocument->createElement("RuleSet");
    $fakerule = $node->ownerDocument->createElement("Rule");
    if (($fakenode)&&($fakerule)) {
	$fakerule->setAttribute("type", "fake");
	$fakerule->setAttribute("target", "");
	$fakerule->setAttribute("test", "");
	$fakerule->setAttribute("threshold", "");
	$fakenode->appendChild($fakerule);
	
	$fakenode->setAttribute("type", "fake");
	$fakenode->setAttribute("name", "fake");
	$fakenode->setAttribute("events", "");
	$fakenode->setAttribute("dummy", "");
	$fakenode->setAttribute("success", "");
	$fakenode->setAttribute("threshold", "0");
	$fakenode->setAttribute("description", "");
	/*if ($cnode->firstChild) $cnode->insertBefore($fakenode, $cnode->firstChild);
	else*/ $cnode->appendChild($fakenode);
    }

    $fakespec = $node->ownerDocument->createElement("Spectrum");
    if ($fakespec) {
	$fakespec->setAttribute("ruleset", "fake");
	$fakespec->setAttribute("sensor", "1");
	$snode->appendChild($fakespec);
    }
}

function config_submit_actions() {
    ?><xf:delete nodeset="/conf/Layout/Coincidences/RuleSet[@type='fake']" at="1"/><?
    ?><xf:delete nodeset="/conf/Layout/Spectrums/Spectrum[@ruleset='fake']" at="1"/><?
}


function config_conf() {
    global $layout;
?><Temp><RS/><RSName/><RSType>custom</RSType><RSEdit type="" index=""/>
<Rule sc="sensor" sc_sensor="sensor" sc_coincidence="" sensor="1" test="active" test_threshold="" threshold="0" delete=""/>
<RSTypes>
    <RSType type="custom">Custom</RSType>
    <RSType type="none">None Of Sensors</RSType>
    <RSType type="one">One Of Sensors</RSType>
    <RSType type="some">Some Of Sensors</RSType>
    <RSType type="all">All Of Sensors</RSType>
    <RSType type="set">Sensor States</RSType>
    <RSType type="and">Conjunction of Coincidences</RSType>
    <RSType type="or">Disjunction Coincidences</RSType>
</RSTypes>
<RuleType index="0" label="Sensor" value="sensor"/>
<RuleType index="1" label="Coincidence" value="coincidence"/>
<Test label="Event" value="true"/>
<Test label="No Event" value="false"/>
<Test label="Above Threshold" value="above"/>
<Test label="Below Threshold" value="below"/>
<Sensors number="<?echo $layout['sensors'];?>"><?
    for ($i=0;$i<$layout['sensors'];$i++) {
    ?><Sensor idx="<?echo $i+1;?>">Sensor <?echo $i+1;?></Sensor><?
    }
?></Sensors>
<Simple/><Custom/><SensorsEdit/><SensorsView>1</SensorsView><SensorsValid/><NSensors/>
<SpecSensor>1</SpecSensor><Spectrums/><NSpectrums/>
</Temp>
<?
}


function config_model() {
    global $layout;
?>
    <xf:bind nodeset="/conf/Temp/RSName" type="xsd:string" constraint="not(/conf/Layout/Coincidences/RuleSet/@name = .)"/>
    <xf:bind nodeset="/conf/Temp/RS" relevant="string-length(/conf/Temp/RSName) &gt; 0 and not(/conf/Layout/Coincidences/RuleSet/@name = /conf/Temp/RSName)"/>
    <xf:bind nodeset="/conf/Layout/Sensors" type="xsd:unsignedInt" constraint="(. &gt; 0) and (. &lt;= <?echo $layout['sensors'];?>)"/>
    <xf:bind nodeset="/conf/Layout/Coincidences/RuleSet/@description" constraint="string-length(.) &gt; 0"/>
    <xf:bind nodeset="/conf/Temp/Rule/@delete" relevant="count(/conf/Layout/Coincidences/RuleSet[@name = /conf/Temp/RSEdit]/Rule) &gt; 1"/>
    <xf:bind nodeset="//Rule/@threshold" type="xsd:unsignedInt" constraint=". &gt;= 0"/>
    <xf:bind nodeset="//RuleSet/@threshold" type="xsd:unsignedInt" constraint=". &gt;= 0"/>

    <xf:bind nodeset="/conf/Temp/Custom" relevant="/conf/Temp/RSType = 'custom'"/>
    <xf:bind nodeset="/conf/Temp/Simple" relevant="/conf/Temp/RSType != 'custom'"/>

    <xf:bind nodeset="/conf/Temp/NSensors" type="xsd:unsignedInt" constraint="(. &gt; 0) and (. &lt;= <?echo $layout['sensors'];?>)"/>
    <xf:bind nodeset="/conf/Temp/SensorsEdit" relevant=". &gt; 0"/>
    <xf:bind nodeset="/conf/Temp/SensorsView" relevant=". &gt; 0"/>
    <xf:bind nodeset="/conf/Temp/SensorsValid" type="xsd:unsignedInt" relevant="(/conf/Temp/NSensors &gt; 0) and (/conf/Temp/NSensors &lt;= <?echo $layout['sensors'];?>)"/>

    <xf:bind nodeset="/conf/Temp/Spectrums" relevant="count(/conf/Layout/Spectrums/Spectrum[@ruleset = /conf/Temp/RSEdit]) &gt; 0"/>
    <xf:bind nodeset="/conf/Temp/NSpectrums" relevant="count(/conf/Layout/Spectrums/Spectrum) &lt;= <?echo $layout['spectrums'];?>"/>

    <?/*<xf:bind id="bind_rule" nodeset="/conf/Layout/Coincidences/RuleSet[@name = /conf/Temp/RSEdit]">*/?>
    <xf:bind id="bind_sensor" nodeset="/conf/Temp/Rule/@sc_sensor" relevant=". = 'sensor'"/>
    <xf:bind id="bind_coincidence" nodeset="/conf/Temp/Rule/@sc_coincidence" relevant=". = 'coincidence'"/>
    <xf:bind id="bind_threshold" nodeset="/conf/Temp/Rule/@test_threshold" relevant="(. = 'above') or (. = 'below')"/>
    <?/*</xf:bind>*/?>
<?}

function config_valid_xpath() {
?> and (count(//RuleSet[@type != 'fake']/Rule[@type='fake']) = 0)<?
}

function set_rule_defaults() {?>
    <xf:setvalue ref="/conf/Temp/Rule/@sc_sensor">sensor</xf:setvalue>
    <xf:setvalue ref="/conf/Temp/Rule/@sc_coincidence"/>
    <xf:setvalue ref="/conf/Temp/Rule/@test_threshold"/>

    <xf:setvalue ref="/conf/Temp/Rule/@sc">sensor</xf:setvalue>
    <xf:setvalue ref="/conf/Temp/Rule/@sensor">1</xf:setvalue>
    <xf:setvalue ref="/conf/Temp/Rule/@test">true</xf:setvalue>
    <xf:setvalue ref="/conf/Temp/Rule/@threshold">0</xf:setvalue>
<?}


function config_page() {
    global $dev, $sensors;
    global $subdevices;
    global $layers;
    global $layout;

?><div class="layoutconfig">
    <xf:repeat nodeset="/conf/Status[text()=0]">
	<div class="control_status">
	    <table width="100%" height="100%"><tr><td>
		<h4>Done</h4>
	    </td></tr></table>
	    <div class="control_status_close">
		<xf:trigger appearance="full" id="trigger">
		    <xf:label></xf:label>
		    <xf:action ev:event="DOMActivate">
			<xf:delete nodeset="/conf/Status" at="1"/>
		    </xf:action>
		</xf:trigger>
	    </div>
	</div>
    </xf:repeat>
    <xf:repeat nodeset="/conf/Status[not(text()=0)]">
	<div class="control_status_highlight">
	    <table width="100%" height="100%"><tr><td>
		<h4>Error: <xf:output ref="/conf/Status"/></h4>
	    </td></tr></table>
	    <div class="control_status_close">
		<xf:trigger appearance="full">
		    <xf:label></xf:label>
		    <xf:action ev:event="DOMActivate">
			<xf:delete nodeset="/conf/Status" at="1"/>
		    </xf:action>
		</xf:trigger>
	    </div>
	</div>
    </xf:repeat><?

    ac_place_submit("Submit");

    ?><br/><br/>
    <table width="100%" height="100%"><tr><td class="layoutleft">
    <div class="sensors">
	<xf:group ref="/conf/Temp/SensorsView">
	  <div class="sensors_view">
	    Sensors: <xf:output ref="/conf/Layout/Sensors"/>
	    <xf:trigger>
		<xf:label>Edit</xf:label>
		<xf:action ev:event="DOMActivate">
		    <xf:setvalue ref="/conf/Temp/NSensors" value="/conf/Layout/Sensors"/>
		    <xf:setvalue ref="/conf/Temp/SensorsEdit">1</xf:setvalue>
		    <xf:setvalue ref="/conf/Temp/SensorsView">0</xf:setvalue>
		</xf:action>
	    </xf:trigger>
	  </div>
	</xf:group>
	<xf:group ref="/conf/Temp/SensorsEdit">
	  <div class="sensors_edit">
	    <xf:input ref="/conf/Temp/NSensors">
		<xf:label>Sensors:</xf:label>
	    </xf:input>
	    <xf:trigger ref="/conf/Temp/SensorsValid">
		<xf:label>Accept</xf:label>
		<xf:action ev:event="DOMActivate">
		    <xf:setvalue value="/conf/Temp/NSensors" ref="/conf/Layout/Sensors"/>
		    <xf:setvalue ref="/conf/Temp/SensorsEdit">0</xf:setvalue>
		    <xf:setvalue ref="/conf/Temp/SensorsView">1</xf:setvalue>
			<? /* forcing formfaces to recalculate group */ ?>
		    <xf:insert nodeset="/conf/Layout/Coincidences/RuleSet" at="last()" position="after"/>
		    <xf:delete nodeset="/conf/Layout/Coincidences/RuleSet" at="last()" position="after"/>
		</xf:action>
	    </xf:trigger>
	    <xf:trigger>
		<xf:label>Cancel</xf:label>
		<xf:action ev:event="DOMActivate">
		    <xf:setvalue ref="/conf/Temp/SensorsEdit">0</xf:setvalue>
		    <xf:setvalue ref="/conf/Temp/SensorsView">1</xf:setvalue>
		</xf:action>
	    </xf:trigger>
	  </div>
	</xf:group>
    </div><br/><br/>
    <div class="ruleset_add">
	<h4>Add Coincidence</h4>
	<p>
	<xf:input ref="/conf/Temp/RSName">
	    <xf:label>Name:</xf:label>
	</xf:input><br/>
	<xf:select1 ref="/conf/Temp/RSType">
	    <xf:label>Type:</xf:label>
	    <xf:itemset nodeset="/conf/Temp/RSTypes/RSType">
		<xf:label ref="."/>
		<xf:value ref="@type"/>
	    </xf:itemset>
	</xf:select1><br/>
	
	<xf:group ref="/conf/Temp/Custom">
	  <xf:trigger ref="/conf/Temp/RS">
	    <xf:label>Add Coincidence</xf:label>
	    <xf:action ev:event="DOMActivate">
		<xf:insert nodeset="/conf/Layout/Coincidences/RuleSet" at="last()" position="before"/>
		<xf:setvalue ref="/conf/Layout/Coincidences/RuleSet[last() - 1]/@type" value="/conf/Temp/RSType"/>
		<xf:setvalue ref="/conf/Layout/Coincidences/RuleSet[last() - 1]/@name" value="/conf/Temp/RSName"/>
		<xf:setvalue ref="/conf/Layout/Coincidences/RuleSet[last() - 1]/@description" value="/conf/Temp/RSName"/>
		<xf:setvalue ref="/conf/Temp/RSEdit" value="/conf/Temp/RSName"/>
		<xf:setvalue ref="/conf/Temp/RSEdit/@type" value="/conf/Temp/RSType"/>
		<xf:setvalue ref="/conf/Temp/RSEdit/@index" value="count(/conf/Layout/Coincidences/RuleSet) - 1"/>
		<xf:setvalue ref="/conf/Temp/RSName"/>
		
		<?set_rule_defaults();?>
	    </xf:action>
	   </xf:trigger>
	 </xf:group>
	<xf:group ref="/conf/Temp/Simple">
	  <xf:trigger ref="/conf/Temp/RS">
	    <xf:label>Add Coincidence</xf:label>
	    <xf:action ev:event="DOMActivate">
		<xf:insert nodeset="/conf/Layout/Coincidences/RuleSet" at="last()" position="before"/>
		<xf:delete ref="/conf/Layout/Coincidences/RuleSet[last() - 1]/Rule[@type = 'fake']" at="1"/>
		<xf:setvalue ref="/conf/Layout/Coincidences/RuleSet[last() - 1]/@type" value="/conf/Temp/RSType"/>
		<xf:setvalue ref="/conf/Layout/Coincidences/RuleSet[last() - 1]/@name" value="/conf/Temp/RSName"/>
		<xf:setvalue ref="/conf/Layout/Coincidences/RuleSet[last() - 1]/@description" value="/conf/Temp/RSName"/>
		<xf:setvalue ref="/conf/Temp/RSEdit" value="/conf/Temp/RSName"/>
		<xf:setvalue ref="/conf/Temp/RSEdit/@type" value="/conf/Temp/RSType"/>
		<xf:setvalue ref="/conf/Temp/RSEdit/@index" value="count(/conf/Layout/Coincidences/RuleSet) - 1"/>
		<xf:setvalue ref="/conf/Temp/RSName"/>
		
		<?set_rule_defaults();?>
	    </xf:action>
	   </xf:trigger>
	 </xf:group>
	</p>
    </div>
    </td><td class="layoutlist">
    <div class="ruleset_list">
	<h3>Configured Coincidences</h3>
	<xf:repeat id="clist" nodeset="/conf/Layout/Coincidences/RuleSet[not(@type='fake')]">
	  <p>
	    <h4>Coincidence <xf:output ref="@name"/></h4>. 
	    <xf:output ref="@description"/><br/>
	    <i>Type</i>: <xf:output ref="@type"/>,
	    <i>Spectrums</i>: <xf:output value="/conf/Layout/Spectrums/Spectrum/@ruleset = @name"/>,
	    <i>Rules</i>: <xf:output value="count(Rule[@type != 'fake'])"/>,
	    <i>Success</i>: <xf:output ref="@success"/><br/>
	    
	    <xf:trigger>
		<xf:label>Edit</xf:label>
		<xf:action ev:event="DOMActivate">
		    <xf:setvalue ref="/conf/Temp/RSEdit" value="/conf/Layout/Coincidences/RuleSet[index('clist')]/@name"/>
		    <xf:setvalue ref="/conf/Temp/RSEdit/@type" value="/conf/Layout/Coincidences/RuleSet[index('clist')]/@type"/>
		    <xf:setvalue ref="/conf/Temp/RSEdit/@index" value="index('clist')"/>
			<? /* forcing formfaces to recalculate group */ ?>
		    <xf:insert nodeset="/conf/Layout/Coincidences/RuleSet" at="last()" position="after"/>
		    <xf:delete nodeset="/conf/Layout/Coincidences/RuleSet" at="last()" position="after"/>
			<? /* xforms-value changed is not dispatched on itemset changes. */ ?>
		    <?set_rule_defaults();?>
		</xf:action>
	    </xf:trigger>
	    <xf:trigger>
		<xf:label>Delete</xf:label>
		<xf:action ev:event="DOMActivate">
		    <? /* There is no other way to delete _all_ spectrums */ 
		    for ($i=0; $i<$layout['spectrums']; $i++) {
			?><xf:delete nodeset="/conf/Layout/Spectrums/Spectrum[@ruleset = /conf/Layout/Coincidences/RuleSet[index('clist')]/@name]" at="1"/><?
		    }?>
		    <xf:delete nodeset="/conf/Layout/Coincidences/RuleSet[not(@type='fake')]" at="index('clist')"/>
		    <xf:setvalue ref="/conf/Temp/RSEdit"/>
		</xf:action>
	    </xf:trigger>
	  </p>
	</xf:repeat>
      </div>
    </td></tr></table>

    <xf:group ref="/conf/Layout/Coincidences/RuleSet[@name = /conf/Temp/RSEdit]">
	<div class="ruleset">
	    <h3>Adjust "<xf:output ref="@name"/>" Configuration</h3>
	    <table>
		<tr><td><i>Type:</i></td><td><xf:output ref="/conf/Temp/RSTypes/RSType[@type = /conf/Temp/RSEdit/@type]"/></td></tr>
		<tr><td><i>Description:</i></td><td><xf:input ref="@description"><xf:label></xf:label></xf:input></td></tr>
	    </table><br/>
	    
	    <table width="100%"><tr><td>
	      <xf:select ref="@events" appearance="full">
		<xf:label></xf:label>
		<xf:item>
		    <xf:label>Collect Events</xf:label>
		    <xf:value>1</xf:value>
		</xf:item>
	      </xf:select>
	      <br/>
	      <xf:select ref="@dummy" appearance="full">
		<xf:label></xf:label>
		<xf:item>
		    <xf:label>Interim</xf:label>
		    <xf:value>1</xf:value>
		</xf:item>
	      </xf:select><br/><br/>
	        <xf:group ref="/conf/Temp/RSEdit[@type = 'custom']">
		  <div class="success">
		    <i>Success Condition</i><br/>
		    N. of Successful Rules:<br/>
		    <xf:select1 ref="/conf/Layout/Coincidences/RuleSet[@name = /conf/Temp/RSEdit]/@success">
			<xf:label></xf:label>
			<xf:item>
			    <xf:label>Above</xf:label>
			    <xf:value>above</xf:value>
			</xf:item>
			<xf:item>
			    <xf:label>Below</xf:label>
			    <xf:value>below</xf:value>
			</xf:item>
		    </xf:select1><br/>
		    
		    <xf:input ref="/conf/Layout/Coincidences/RuleSet[@name = /conf/Temp/RSEdit]/@threshold">
			<xf:label></xf:label>
		    </xf:input>
		  </div><br/>
		  
		  <div class="newrule">
		    <i>Add New Rule</i><br/>
		    <xf:select1 ref="/conf/Temp/Rule/@sc">
			<xf:label>Type: </xf:label>
			<xf:itemset nodeset="/conf/Temp/RuleType[@index &lt; /conf/Temp/RSEdit/@index]">
			    <xf:label ref="@label"/>
			    <xf:value ref="@value"/>
			</xf:itemset>
			<xf:action ev:event="xforms-value-changed">
			    <xf:setvalue ref="/conf/Temp/Rule/@sc_sensor" value="/conf/Temp/Rule/@sc"/>
			    <xf:setvalue ref="/conf/Temp/Rule/@sc_coincidence" value="/conf/Temp/Rule/@sc"/>
			</xf:action>
		    </xf:select1>

		    <xf:group ref="/conf/Temp/Rule/@sc_sensor">
			<xf:select1 ref="../@sensor" appearance="minimal">
			    <xf:label>Item: </xf:label>
			    <xf:itemset nodeset="/conf/Temp/Sensors/Sensor[@idx &lt;= /conf/Layout/Sensors]">
				<xf:label ref="."/>
				<xf:value ref="@idx"/>
			    </xf:itemset>
			</xf:select1>
		    </xf:group>
		    <xf:group ref="/conf/Temp/Rule/@sc_coincidence">
			<xf:select1 ref="../@sensor" appearance="minimal">
			    <xf:label>Item: </xf:label>
			    <xf:itemset nodeset="/conf/Layout/Coincidences/RuleSet[position() &lt; /conf/Temp/RSEdit/@index]">
				<xf:label ref="@description"/>
				<xf:value ref="@name"/>
			    </xf:itemset>
			</xf:select1>
		    </xf:group>

		    <xf:select1 ref="/conf/Temp/Rule/@test">
			<xf:label>Test:</xf:label>
			<xf:itemset nodeset="/conf/Temp/Test">
			    <xf:label ref="@label"/>
			    <xf:value ref="@value"/>
			</xf:itemset>
			<xf:action ev:event="xforms-value-changed">
			    <xf:setvalue ref="/conf/Temp/Rule/@test_threshold" value="/conf/Temp/Rule/@test"/>
			</xf:action>
		    </xf:select1>

		    <xf:group ref="/conf/Temp/Rule/@test_threshold">
			<xf:input ref="/conf/Temp/Rule/@threshold">
			    <xf:label>Threshold:</xf:label>
			</xf:input>
		    </xf:group>
		    
		    <xf:trigger>
			<xf:label>Add Rule</xf:label>
			<xf:action ev:event="DOMActivate">
			    <xf:insert nodeset="/conf/Layout/Coincidences/RuleSet[@name = /conf/Temp/RSEdit]/Rule" at="last()" position="after"/>
			    <xf:setvalue ref="/conf/Layout/Coincidences/RuleSet[@name = /conf/Temp/RSEdit]/Rule[last()]/@type" value="/conf/Temp/Rule/@sc"/>
			    <xf:setvalue ref="/conf/Layout/Coincidences/RuleSet[@name = /conf/Temp/RSEdit]/Rule[last()]/@target" value="/conf/Temp/Rule/@sensor"/>
			    <xf:setvalue ref="/conf/Layout/Coincidences/RuleSet[@name = /conf/Temp/RSEdit]/Rule[last()]/@test" value="/conf/Temp/Rule/@test"/>
			    <xf:setvalue ref="/conf/Layout/Coincidences/RuleSet[@name = /conf/Temp/RSEdit]/Rule[last()]/@threshold" value="/conf/Temp/Rule/@threshold"/>
			    <xf:delete nodeset="/conf/Layout/Coincidences/RuleSet[@name = /conf/Temp/RSEdit]/Rule[@type='fake']" at="1"/>
			</xf:action>
		    </xf:trigger>
		  </div>
		</xf:group>
		<br/>
		<div class="newspectrum">
		    <i>Add New Spectrum</i><br/>
		    <xf:select1 ref="/conf/Temp/SpecSensor" appearance="minimal">
			<xf:label></xf:label>
			<xf:itemset nodeset="/conf/Temp/Sensors/Sensor[@idx &lt;= /conf/Layout/Sensors]">
			    <xf:label ref="."/>
			    <xf:value ref="@idx"/>
			</xf:itemset>
		    </xf:select1>
		    <xf:trigger ref="/conf/Temp/NSpectrums">
			<xf:label>Add Spectrum</xf:label>
			<xf:action ev:event="DOMActivate">
			    <xf:insert nodeset="/conf/Layout/Spectrums/Spectrum" at="last()" position="before"/>
			    <xf:setvalue ref="/conf/Layout/Spectrums/Spectrum[last() - 1]/@sensor" value="/conf/Temp/SpecSensor"/>
			    <xf:setvalue ref="/conf/Layout/Spectrums/Spectrum[last() - 1]/@ruleset" value="/conf/Temp/RSEdit"/>
			</xf:action>
		    </xf:trigger>
		</div>

	     </td><td>
	        <xf:group ref="/conf/Temp/RSEdit[@type = 'custom']">
		  <div class="rulelist">
		    <i>Configured Rules</i><br/>
		    <table width="100%">
		     <thead>
		      <tr><th>Target</th><th>Test</th><th>Delete</th></tr>
		     </thead>

		     <tbody id="rlist" xf:repeat-nodeset="/conf/Layout/Coincidences/RuleSet[@name = /conf/Temp/RSEdit]/Rule[@type != 'fake']">
		      <tr>
			<td><xf:output ref="@type"/> <xf:output ref="@target"/></td>
			<td><xf:output ref="@test"/>
			    <xf:output ref="if((@test = 'above') or (@test = 'below'),@threshold,'')"/>
			</td>
			<td><xf:group ref="/conf/Temp/Rule/@delete">
			  <xf:trigger>
			    <xf:label>Delete</xf:label>
			    <xf:action ev:event="DOMActivate">
				<xf:delete nodeset="/conf/Layout/Coincidences/RuleSet[@name = /conf/Temp/RSEdit]/Rule" at="index('rlist')"/>
			    </xf:action>
			  </xf:trigger>
			</xf:group></td>
		      </tr>
		     </tbody>
		    </table>
		  </div>
		</xf:group>
	        <xf:group ref="/conf/Temp/RSEdit[@type = 'none' or @type = 'one' or @type = 'some' or @type = 'all' or @type = 'set']">
		    <i>Select Sensors:</i><br/>
		    <xf:select ref="/conf/Layout/Coincidences/RuleSet[@name = /conf/Temp/RSEdit]/@success" appearance="full">
			<xf:label></xf:label>
			<xf:itemset nodeset="/conf/Temp/Sensors/Sensor[@idx &lt;= /conf/Layout/Sensors]">
			    <xf:label ref="."/>
			    <xf:value ref="@idx"/>
			</xf:itemset>
		    </xf:select>
		</xf:group>
	        <xf:group ref="/conf/Temp/RSEdit[@type = 'or' or @type = 'and']">
		    <i>Select Coincidences:</i><br/>
		    <xf:select ref="/conf/Layout/Coincidences/RuleSet[@name = /conf/Temp/RSEdit]/@success" appearance="full">
			<xf:label></xf:label>
			<xf:itemset nodeset="/conf/Layout/Coincidences/RuleSet[position() &lt; /conf/Temp/RSEdit/@index]">
				<xf:label ref="@description"/>
				<xf:value ref="@name"/>
			</xf:itemset>
		    </xf:select>
		</xf:group>

		<br/><br/>
		<xf:group ref="/conf/Temp/Spectrums">
		  <div class="spectrumlist">
		    <i>Configured Spectrums</i><br/>
		    <table width="100%">
		     <thead>
		      <tr><th>Sensor</th><th>Delete</th></tr>
		     </thead>

		     <tbody id="slist" xf:repeat-nodeset="/conf/Layout/Spectrums/Spectrum[@ruleset = /conf/Temp/RSEdit]">
		      <tr>
			<td>Sensor <xf:output ref="@sensor"/></td>
			<td>
			  <xf:trigger>
			    <xf:label>Delete</xf:label>
			    <xf:action ev:event="DOMActivate">
				<xf:delete nodeset="/conf/Layout/Spectrums/Spectrum[@ruleset = /conf/Temp/RSEdit]" at="index('slist')"/>
			    </xf:action>
			  </xf:trigger>
			</td>
		      </tr>
		     </tbody>
		    </table>
		  </div>
		</xf:group>
	     </td></tr></table>
	</div>
      </xf:group>

    <?
    // listing already configured devices

    
?></div><?
}


$mcu_info = parse_mcu_info($dev['name']);
if ($mcu_info['layout']) {
    $layout = &$mcu_info['layout'];
} else {
    $control_not_supported = 1;
}

?>