<?

function config_list_category($catname, &$configured) {
    global $dev, $sensors;
    global $subdevices;
    global $layers;

    $res = "";
    
    for  ($d=0;$d<$subdevices["subdevices"];$d++) {
	$spr = $subdevices["subdevice"][$d]["sensors"]/$layers;
	if ($subdevies["subdevices"]>1) $devname = $dev["name"] . "-" . ($d+1);
	else $devname = $dev["name"];

      for ($j=1;$j<=$spr;$j++) {
	for ($i=1;$i<=$layers;$i++) {
	    $configured["$devname-$i-$j"] = 1;
	    $res .= "<$catname device=\"$devname\" layer=\"$i\" sensor=\"$j\">0</$catname>";
	}
      }
    }
    return $res;
}


function config_valid() {
    global $dev, $sensors;

    for ($i=0;$i<$sensors;$i++) {
	$sid = $i + 1;
	?><ValidVoltage id="<?echo $sid;?>">1</ValidVoltage><?
	?><ValidThreshold id="<?echo $sid;?>">1</ValidThreshold><?
	?><ValidSoftwareThreshold id="<?echo $sid;?>">1</ValidSoftwareThreshold><?
    }
}

function config_selected() {
    ?><Sensor>0</Sensor><?
}

function config_model() {?>
    <xf:bind nodeset="/conf/Voltages/Voltage" type="xsd:unsignedInt" constraint="(. &lt; 3000) and (. &gt; 900)"/>
    <xf:bind nodeset="/conf/Thresholds/Threshold" type="xsd:double" constraint="(. &lt; 2.55) and (. &gt; 0)"/>
    <xf:bind nodeset="/conf/Configuration/SoftwareThresholds/SoftwareThreshold" type="xsd:unsignedInt" constraint="(. &lt;= 128) and (. &gt; 0)"/>
<?}

function config_head() {
    global $dev, $sensors;
    global $hv_renewal_time;

    js_set_iframe_height("tracking_frame");
    ?><script type="text/javascript" src="js/xml.js"></script><?
    ?><script type="text/javascript" src="js/scrolling.js"></script><?
    ?><script type="text/javascript" src="js/setvalues.js"></script><?
    ?><script type="text/javascript" src="js/graph.js"></script><?
    ?><script type="text/javascript" src="js/checkvoltage.js"></script><?

    ?><script type="text/javascript" ev:event="onload">
	valueRunner("xml/voltages.xml?detector=<?echo $_GET["detector"];?>", valueHandler, "hv", 15000, <?echo $hv_renewal_time;?>);
	valueRunner("xml/values.xml?detector=<?echo $_GET["detector"];?>", valueHandler, "counter", 15000, <?echo $hv_renewal_time;?>);
	checkerSetup(<?echo $sensors;?>, 15000, 1000);
	var spectrum_graph = graphSetup("spectrum", "xml/spectrum.xslt", "xml/spectrum.xml?detector=<?echo $_GET["detector"];?>", 15000, 2000);
	scrollingSetup(new Array("spectrum-selected-div"));
    </script><?
}


function config_page() {
    global $dev, $sensors;
    global $configured_voltages;
    global $configured_thresholds;
    global $subdevices;
    global $layers;

    ?>
<div class="namtconfig">
    <xf:repeat nodeset="/conf/Status[text()=0]">
	<div class="control_status">
	    <table width="100%" height="100%"><tr><td>
		<h4>Done</h4>
	    </td></tr></table>
	    <div class="control_status_close">
		<xf:trigger appearance="full" id="trigger">
		    <xf:label></xf:label>
		    <xf:action ev:event="DOMActivate">
			<xf:delete nodeset="/conf/Status" at="1"/>
		    </xf:action>
		</xf:trigger>
	    </div>
	</div>
    </xf:repeat>
    <xf:repeat nodeset="/conf/Status[text()!=0]">
	<div class="control_status_highlight">
	    <table width="100%" height="100%"><tr><td>
		<h4>Error: <xf:output ref="/conf/Status"/></h4>
	    </td></tr></table>
	    <div class="control_status_close">
		<xf:trigger appearance="full">
		    <xf:label></xf:label>
		    <xf:action ev:event="DOMActivate">
			<xf:delete nodeset="/conf/Status" at="1"/>
		    </xf:action>
		</xf:trigger>
	    </div>
	</div>
    </xf:repeat>
    <?/*<xf:switch><xf:case id="0"/><xf:case id="1">*/?>
	<div id="spectrum-selected-div" name="spectrum-selected-div" class="spectrum_selected" style="display: none;">
	    <h4>Detctor <span id="spectrum-selected-id" name="spectrum-selected-id"><?/*<xf:output ref="/conf/Selected/Sensor"/>*/?></span></h4>
	    <table width="100%" height="100%"><tr><td>
		<div id="spectrum-selected" name="spectrum-selected">Loading...</div>
	    </td></tr></table>
	    <div class="spectrum_selected_close">
		<button onclick="graphSelect(spectrum_graph, 0);" style="width: 100%; height: 100%;"/>
		<?/*<xf:trigger appearance="full">
		    <xf:label></xf:label>
		    <xf:action ev:event="DOMActivate">
			<xf:setvalue ref="/conf/Selected/Sensor" value="0"/>
		    </xf:action>
		    <xf:toggle case="0" ev:event="DOMActivate"/>
		</xf:trigger>*/?>
	    </div>
	</div>
    <?/*</xf:case></xf:switch>*/?>
    <?

    ac_place_submit("Submit");

    for  ($dp=0,$d=0;$d<$subdevices["subdevices"];$d++,$dp+=$layers*$spr) {
      $spr = $subdevices["subdevice"][$d]["sensors"]/$layers;
      if ($subdevies["subdevices"]>1) $devname = $dev["name"] . "-" . ($d+1);
      else $devname = $dev["name"];
	
    ?><table width="100%" height="100%" class="config"><?
      for ($j=0;$j<$spr;$j++) {
	echo "<tr>";
	for ($i=0;$i<$layers;$i++) {
	    $sid = $dp + $i*$spr + $j + 1;
?>
	  <td>
	    <div name="detector-<?echo ($sid);?>" id="detector-<?echo ($sid);?>" class="detector">
	    <?if ($layers > 1) {
	      ?><h4>Channel <?echo $sid;?> (Layer: <?echo $i+1;?>, Sensor: <?echo $j+1;?>)</h4><?
	    } else {
	      ?><h4>Channel <?echo $sid;?> (Sensor: <?echo $j+1;?>)</h4><?
	    }?>
	      <table width="100%" height="100%"><tr><td>
<?	    $vid = $devname . "-" . ($i+1) . "-" . ($j+1);
	    if ($configured_voltages[$vid]) {?>
		<div name="hv-input-<?echo ($sid);?>" id="hv-input-<?echo ($sid);?>">
		  <xf:input ref="/conf/Voltages/Voltage[@device='<?echo $devname;?>' and @layer=<?echo ($i+1);?> and @sensor=<?echo ($j+1);?>]">
		    <xf:label>High Voltage (V):<br/></xf:label>
		    <xf:action ev:event="DOMFocusIn">
			<xf:delete nodeset="/conf/Status" at="1"/>
		    </xf:action>
		    <xf:action ev:event="xforms-invalid">
			<xf:setvalue value="0" ref="/conf/Valid/ValidVoltage[@id='<?echo $sid;?>']"/>
		    </xf:action>
		    <xf:action ev:event="xforms-valid">
			<xf:setvalue value="1" ref="/conf/Valid/ValidVoltage[@id='<?echo $sid;?>']"/>
		    </xf:action>
		  </xf:input>
		</div>
<?	    }
	    if ($configured_thresholds[$vid]) {?>
		<div name="threshold-input-<?echo ($sid);?>" id="threshold-input-<?echo ($sid);?>">
		  <xf:input ref="/conf/Thresholds/Threshold[@device='<?echo $devname;?>' and @layer=<?echo ($i+1);?> and @sensor=<?echo ($j+1);?>]">
		    <xf:label>Threshold (V):<br/></xf:label>
		    <xf:action ev:event="DOMFocusIn">
			<xf:delete nodeset="/conf/Status" at="1"/>
		    </xf:action>
		    <xf:action ev:event="xforms-invalid">
			<xf:setvalue value="0" ref="/conf/Valid/ValidThreshold[@id='<?echo $sid;?>']"/>
		    </xf:action>
		    <xf:action ev:event="xforms-valid">
			<xf:setvalue value="1" ref="/conf/Valid/ValidThreshold[@id='<?echo $sid;?>']"/>
		    </xf:action>
		  </xf:input>
		</div>
<?	    }?>
		<div name="software-threshold-input-<?echo ($sid);?>" id="software-threshold-input-<?echo ($sid);?>">
	    <?if ($subdevies["subdevices"]>1) {
		if ($layers>1) {
		  ?><xf:input ref="/conf/Configuration/SoftwareThresholds/SoftwareThreshold[@device='<?echo $devname;?>' and @layer=<?echo ($i+1);?> and @sensor=<?echo ($j+1);?>]"><?
		} else {
		  ?><xf:input ref="/conf/Configuration/SoftwareThresholds/SoftwareThreshold[@device='<?echo $devname;?>' and @sensor=<?echo ($j+1);?>]"><?
		}
	    } else {
		if ($layers>1) {
		  ?><xf:input ref="/conf/Configuration/SoftwareThresholds/SoftwareThreshold[@layer=<?echo ($i+1);?> and @sensor=<?echo ($j+1);?>]"><?
		} else {
		  ?><xf:input ref="/conf/Configuration/SoftwareThresholds/SoftwareThreshold[@sensor=<?echo ($j+1);?>]"><?
		}
	    }?>		  
		    <xf:label>SoftThreshold :<br/></xf:label>
		    <xf:action ev:event="DOMFocusIn">
			<xf:delete nodeset="/conf/Status" at="1"/>
		    </xf:action>
		    <xf:action ev:event="xforms-invalid">
			<xf:setvalue value="0" ref="/conf/Valid/ValidSoftwareThreshold[@id='<?echo $sid;?>']"/>
		    </xf:action>
		    <xf:action ev:event="xforms-valid">
			<xf:setvalue value="1" ref="/conf/Valid/ValidSoftwareThreshold[@id='<?echo $sid;?>']"/>
		    </xf:action>
		  </xf:input>
		</div>
		<br/>
		High Voltage: <span id="hv-<?echo ($sid);?>">Loading...</span><br/>
		Cur. Counter: <span id="counter-<?echo ($sid);?>">Loading...</span><br/>
	      </td><td height="100%" class="spectrum">
	        <div id="spectrum-<?echo $sid;?>" name="spectrum-<?echo $sid;?>" onclick="graphSelect(spectrum_graph, '<?echo $sid;?>');">Loading Spectrum...</div>
		<?/*<xf:trigger id="trigger<?echo $sid;?>" appearance="minimal">
		    <xf:label></xf:label>
		    <xf:action ev:event="DOMActivate">
			<xf:setvalue ref="/conf/Selected/Sensor" value="<?echo $sid;?>"/>
		    </xf:action>
		    <xf:toggle case="1" ev:event="DOMActivate"/>
		</xf:trigger>
		<xf:dispatch ev:event="click" name="DOMActivate" target="trigger<?echo $sid;?>"/>*/?>
	      </td></tr></table>
	    </div>
	  </td>
<?    	}
	echo "</tr>";
      }
    ?></table><?
    }
?></div><?
}


exec("adas-simple -cm /" .  $dev["name"]);


$mcu_info = parse_mcu_info($dev['name']);

$start_time = time();
while (($mcu_info['status'])||($mcu_info['mode']!=1)) {
    usleep(50000);
    $mcu_info = parse_mcu_info($dev['name']);
    if ((time() - $start_time) > $TIMEOUT) {
        $error = "<span class=\"highlight\">Timeout entering configuration mode!</span>";
        return;
    }
}


if (!strcasecmp($mcu_info['type'], "SNT")) {
    $layers = 2;
} elseif (!strcasecmp($mcu_info['type'], "SA")) {
    $layers = 1;
} else {
    $control_not_supported = 1;
}

if (!$control_not_supported) {
    $voltage_sub = "control";
    $threshold_sub = "control";

    $adas_timeout = $TIMEOUT * 1000;
        
    $hv_renewal_time = time();
    exec("adas-simple --retries 1 --timeout $adas_timeout -cr /" . $dev["name"] . " 'VR'");
    $hv_renewal_time = time() - $hv_renewal_time;

    if ($hv_renewal_time < 1) $hv_renewal_time = 2000;
    else $hv_renewal_time*=2000; /* get twice */
}


?>