<?
function config_valid() {
    global $dev, $sensors;

    $spr = $sensors/3;
    for ($i=0;$i<3;$i++) {
	for ($j=0;$j<$spr;$j++) {
	    $sid = $i*$spr+$j + 1;
	    ?><ValidVoltage id="<?echo $sid;?>">1</ValidVoltage><?
	    ?><ValidThreshold id="<?echo $sid;?>">1</ValidThreshold><?
	}
    }
}

function config_model() {?>
    <xf:bind nodeset="/conf/Voltages/Voltage" type="xsd:unsignedInt" constraint="(. &lt; 3000) and (. &gt; 900)"/>
    <xf:bind nodeset="/conf/Configuration/Thresholds/Threshold" type="xsd:double" constraint="(. &lt; 2.55) and (. &gt;= 0)"/>
<?}

function config_head() {
    global $dev, $sensors;

    $spr = $sensors/3;

    js_set_iframe_height("tracking_frame");
    ?><script type="text/javascript" src="js/xml.js"/><?
    ?><script type="text/javascript" src="js/setvalues.js"/><?
    ?><script type="text/javascript">valueRunner("xml/voltages.xml?detector=<?echo $_GET["detector"];?>"<?/*"*/?>, valueHandler, "hv", 5000, 2000);</script><?
    ?><script type="text/javascript" src="js/checkvoltage.js"/><?
    ?><script type="text/javascript">
	checkerSetup(<?echo $sensors;?>, 5000, 1000);
    </script><?
}


function config_page() {
    global $dev, $sensors;
    global $configured_voltages;

    $spr = $sensors/3;

    ?>
    <xf:repeat nodeset="/conf/Status[text()=0]">
	<div class="control_status">
	    <table width="100%" height="100%"><tr><td>
		<h4>Done</h4>
	    </td></tr></table>
	    <div class="control_status_close">
		<xf:trigger appearance="full" id="trigger">
		    <xf:label></xf:label>
		    <xf:action ev:event="DOMActivate">
			<xf:delete nodeset="/conf/Status" at="1"/>
		    </xf:action>
		</xf:trigger>
	    </div>
	</div>
    </xf:repeat>
    <xf:repeat nodeset="/conf/Status[text()!=0]">
	<div class="control_status_highlight">
	    <table width="100%" height="100%"><tr><td>
		<h4>Error: <xf:output ref="/conf/Status"/></h4>
	    </td></tr></table>
	    <div class="control_status_close">
		<xf:trigger appearance="full">
		    <xf:label></xf:label>
		    <xf:action ev:event="DOMActivate">
			<xf:delete nodeset="/conf/Status" at="1"/>
		    </xf:action>
		</xf:trigger>
	    </div>
	</div>
    </xf:repeat>
    <?

    ?><table width="100%" height="100%" class="config"><?

    for ($i=0;$i<3;$i++) {
	echo "<tr>";
	for ($j=0;$j<$spr;$j++) {
	    $sid = $i*$spr+$j + 1;
?>
	    <td>
	      <div name="detector-<?echo ($i+1);?>-<?echo ($j+1);?>" id="detector-<?echo ($i+1);?>-<?echo ($j+1);?>" class="detector">
		<h4>Detector <?echo $sid;?></h4>
<?	    $vid = $dev["name"] . "-" . ($i+1) . "-" . ($j+1);
	    if ($configured_voltages[$vid]) {?>
		<div name="hv-input-<?echo ($sid);?>" id="hv-input-<?echo ($sid);?>">
		  <xf:input ref="/conf/Voltages/Voltage[@layer=<?echo ($i+1);?> and @sensor=<?echo ($j+1);?>]">
		    <xf:label>High Voltage (V):<br/></xf:label>
		    <xf:action ev:event="DOMFocusIn">
			<xf:delete nodeset="/conf/Status" at="1"/>
		    </xf:action>
		    <xf:action ev:event="xforms-invalid">
			<xf:setvalue value="0" ref="/conf/Valid/ValidVoltage[@id='<?echo $sid;?>']"/>
		    </xf:action>
		    <xf:action ev:event="xforms-valid">
			<xf:setvalue value="1" ref="/conf/Valid/ValidVoltage[@id='<?echo $sid;?>']"/>
		    </xf:action>
		  </xf:input>
		</div>
<?	    }?>
		<div name="threshold-input-<?echo ($sid);?>" id="threshold-input-<?echo ($sid);?>">
		  <xf:input ref="/conf/Configuration/Thresholds/Threshold[@layer=<?echo ($i+1);?> and @sensor=<?echo ($j+1);?>]">
		    <xf:label>Threshold (V):<br/></xf:label>
		    <xf:action ev:event="DOMFocusIn">
			<xf:delete nodeset="/conf/Status" at="1"/>
		    </xf:action>
		    <xf:action ev:event="xforms-invalid">
			<xf:setvalue value="0" ref="/conf/Valid/ValidThreshold[@id='<?echo $sid;?>']"/>
		    </xf:action>
		    <xf:action ev:event="xforms-valid">
			<xf:setvalue value="1" ref="/conf/Valid/ValidThreshold[@id='<?echo $sid;?>']"/>
		    </xf:action>
		  </xf:input>
		</div>
		<br/>
		High Voltage: <span id="hv-<?echo ($sid);?>">-1</span><br/>
	      </div>
	    </td>
<?	    if ($i == 0) {?>
	    <td class="right_frame" rowspan="4" width="100%" height="100%">
		<iframe src="index.php?page=xmldata.php&amp;detector=<?echo $_GET["detector"];?>&amp;device=<?echo $_GET["detector"];?>&amp;noleft&amp;noheader&amp;iframe=tracking_frame&amp;update" id="tracking_frame" name="tracking_frame"/>
	    </td>
<?	    }
	}
	echo "</tr>";
    }

?>
    <tr><td align="center" colspan="<?echo $spr;?>"><?
	ac_place_submit("Submit");
/*
	<xf:submit submission="form">
	    <xf:label>Submit</xf:label>
	</xf:submit>
*/
    ?></td></tr>
    </table>
<?
    
/*    <p id="status"></p> */
}


?>