<?xml version="1.0"?> 
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/1999/xhtml">
 <xsl:output method="xml" version="1.1" encoding="utf-8" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"/>

 <xsl:template match="info">
    <span class="highlight"><xsl:value-of select="@title"/></span>: <xsl:value-of select="."/><br/>
    <xsl:element name="input">
	<xsl:attribute name="type">hidden</xsl:attribute>
	<xsl:attribute name="value"><xsl:value-of select="."/></xsl:attribute>
	<xsl:attribute name="name"><xsl:value-of select="@title"/></xsl:attribute>
    </xsl:element>
 </xsl:template>
 
 <xsl:template name="Device">
    <xsl:element name="div">
	<xsl:choose>
	    <xsl:when test="dublicate">
		<xsl:attribute name="class">usb_device_dublicate</xsl:attribute>
	    </xsl:when>
	    <xsl:when test="multirule">
		<xsl:attribute name="class">usb_device_multirule</xsl:attribute>
	    </xsl:when>
	    <xsl:when test="multiname">
		<xsl:attribute name="class">usb_device_multiname</xsl:attribute>
	    </xsl:when>
	    <xsl:when test="device = ''">
		<xsl:attribute name="class">usb_device_notset</xsl:attribute>
	    </xsl:when>
	    <xsl:otherwise>
		<xsl:attribute name="class">usb_device</xsl:attribute>
	    </xsl:otherwise>
	</xsl:choose>
	<h4>USB Device: <xsl:value-of select="@id"/></h4>
	<xsl:choose>
	    <xsl:when test="dublicate">
		<i>Impossible to distinguish several devices. Please set appropriate serial numbers.</i><br/>
	    </xsl:when>
	    <xsl:when test="multirule">
		<i>Multiple UDEV rules applies to this device. Please update.</i><br/>
	    </xsl:when>
	    <xsl:when test="multiname">
		<i>The same name is set for the several devices. Please update.</i><br/>
	    </xsl:when>
	</xsl:choose>
	<br/>
	
	<xsl:element name="form">
	    <xsl:attribute name="action">index.php?page=usbdb.php</xsl:attribute>
	    <xsl:attribute name="method">POST</xsl:attribute>
	    <xsl:attribute name="name"><xsl:value-of select="@id"/></xsl:attribute>
	    <xsl:attribute name="enctype">application/x-www-form-urlencoded</xsl:attribute>

	    <span class="highlight">Device Name</span>:<br/>
	    <xsl:element name="input">
		<xsl:attribute name="type">text</xsl:attribute>
		<xsl:attribute name="value"><xsl:value-of select="device"/></xsl:attribute>
		<xsl:attribute name="name">device</xsl:attribute>
		<xsl:attribute name="title">
		    <xsl:for-each select="../Configured/Device">
			<xsl:value-of select="."/><xsl:text> </xsl:text>
		    </xsl:for-each>
		</xsl:attribute>
	    </xsl:element><br/><br/>
	    <xsl:apply-templates select="info"/><br/>
	    <input type="submit" value="Setup"/>
	</xsl:element>
    </xsl:element>
 </xsl:template>

 <xsl:template match="Devices">
    <xsl:if test="not(Device)">
	No USB device connected
    </xsl:if>
    <xsl:for-each select="Device">
	<xsl:call-template name="Device"/><br/><br/>
    </xsl:for-each>
 </xsl:template>

 <xsl:template match="@*|node()">
   <xsl:copy>
     <xsl:apply-templates select="@*|node()"/>
   </xsl:copy>
 </xsl:template>
</xsl:stylesheet>
