<?header("Content-Type: application/xml");
require("../config.php");
if (isset($_GET["selected"])) $selected = 1; else $selected = 0;
if (isset($_GET["normalize"])) $normalize = 1; else $normalize = 0;
echo "<?xml version=\"1.0\"?>";?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xhtml="http://www.w3.org/1999/xhtml" xmlns="http://www.w3.org/2000/svg">
 <xsl:output method="xml" version="1.0" encoding="utf-8" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"/>

 <xsl:template match="Value">
    <xsl:param name="size"/>
    <xsl:param name="xscale"/>
    <xsl:param name="ymove"/>
    <xsl:param name="yscale"/>

    <xsl:choose>
	<xsl:when test="@id = 1">M<xsl:value-of select="1 + @from * $xscale"/>,<xsl:value-of select="1 + $ymove + $size - (. * $yscale)"/></xsl:when>
	<xsl:otherwise>
	    <xsl:if test="preceding-sibling::*[1]/@to &lt; @from">
		<xsl:text>V</xsl:text><xsl:value-of select="$size + 1"/><xsl:text> H</xsl:text><xsl:value-of select="1 + @from * $xscale"/><xsl:text> L</xsl:text>
	    </xsl:if>
	</xsl:otherwise>
    </xsl:choose>
    <xsl:text> </xsl:text>
    <xsl:value-of select="1 + @to * $xscale"/>,<xsl:value-of select="1 + $ymove + $size - (. * $yscale)"/>
 </xsl:template>
 
 <xsl:template match="//Graph[not(@nodata)]">
<?if ($selected) {?>
    <xsl:param name="scale">3</xsl:param>
    <xsl:param name="shift">75</xsl:param>
    <xsl:param name="size">120</xsl:param>

    <xsl:param name="xout" select="$scale * $size + 16"/>
<?} else {?>
    <xsl:param name="scale">1</xsl:param>
    <xsl:param name="shift">8</xsl:param>
    <xsl:param name="size">120</xsl:param>
<?}?>
    <xsl:param name="xscale"><xsl:value-of select="$size div (../@to - ../@from)"/></xsl:param>
<?if ($normalize) {?>
    <xsl:param name="ymove"><xsl:value-of select="$size * @min div (1 + @max - @min)"/></xsl:param>
    <xsl:param name="yscale"><xsl:value-of select="$size div (1 + @max - @min)"/></xsl:param>
<?} else {?>
    <xsl:param name="ymove">0</xsl:param>
    <xsl:param name="yscale"><xsl:value-of select="$size div (../@max)"/></xsl:param>
<?}?>
<?if (!isset($_GET["skipchecks"])) {?>
    <xsl:param name="missed" select="(@last_time - @first_time) - (sum(Value/@to) - sum(Value/@from))"/>
    <xsl:param name="lastwrite" select="(../@to - @last_time)"/>
    <xsl:param name="invalid" select="count(Value[. &lt; 1])"/>
    <xsl:param name="vratio" select="100 * @variance div (@mean + 1)"/>
    <xsl:param name="problematic" select="$missed &gt; <?echo $REPORT_MISSED_SECONDS;?> or $lastwrite &gt; <?echo $REPORT_NODATA_TIMEOUT;?> or $invalid &gt; <?echo $REPORT_INVALID_ENTRIES;?> or vratio &gt; <?echo $REPORT_LARGE_VARIANCE;?>"/>
<?} else {?>
    <xsl:param name="problematic">1</xsl:param>
<?}?>

    <xsl:element name="svg">
      <xsl:attribute name="width"><xsl:value-of select="2 * $shift + $scale * $size + 3"/></xsl:attribute>
      <xsl:attribute name="height"><xsl:value-of select="2 * $shift + $scale * $size + 4"/></xsl:attribute>
      <g>
        <xsl:element name="rect">
	    <xsl:attribute name="x"><xsl:value-of select="1"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift - 3"/></xsl:attribute>
	    <xsl:attribute name="width"><xsl:value-of select="$scale * $size + 1"/></xsl:attribute>
	    <xsl:attribute name="height"><xsl:value-of select="$scale * $size + 6"/></xsl:attribute>
	    <xsl:choose>
	        <xsl:when test="$problematic"> 
		    <xsl:attribute name="fill">#E9D88D</xsl:attribute>
		    <xsl:attribute name="stroke">#FFB0B0</xsl:attribute>
		    <xsl:attribute name="stroke-width">2</xsl:attribute>
		</xsl:when>
		<xsl:otherwise>
		    <xsl:attribute name="fill">#E0E0E0</xsl:attribute>
		    <xsl:attribute name="stroke">blue</xsl:attribute>
		    <xsl:attribute name="stroke-width">2</xsl:attribute>
		</xsl:otherwise>
	    </xsl:choose>
	</xsl:element>
<?if ($selected) {?>
	<xsl:element name="text">
	    <xsl:attribute name="x"><xsl:value-of select="1"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift + $scale * $size + 16"/></xsl:attribute>
	    <xsl:attribute name="font-size">14</xsl:attribute>
	    <xsl:value-of select="../@from_text"/>
	</xsl:element>

	<xsl:element name="text">
	    <xsl:attribute name="x"><xsl:value-of select="$scale * $size - 60"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift + $scale * $size + 16"/></xsl:attribute>
	    <xsl:attribute name="font-size">14</xsl:attribute>
	    <xsl:value-of select="../@to_text"/>
	</xsl:element>

	<xsl:element name="text">
	    <xsl:attribute name="x"><xsl:value-of select="$xout"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift + 16"/></xsl:attribute>
	    <xsl:attribute name="font-size">14</xsl:attribute>
	    <xsl:text>Mean:</xsl:text>
	</xsl:element>
	<xsl:element name="text">
	    <xsl:attribute name="x"><xsl:value-of select="$xout"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift + 32"/></xsl:attribute>
	    <xsl:attribute name="font-size">14</xsl:attribute>
	    <xsl:value-of select="round(@mean)"/>
	</xsl:element>
	<xsl:element name="text">
	    <xsl:attribute name="x"><xsl:value-of select="$xout"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift + 48"/></xsl:attribute>
	    <xsl:attribute name="font-size">14</xsl:attribute>
	    <xsl:text>Variance:</xsl:text>
	</xsl:element>
	<xsl:element name="text">
	    <xsl:attribute name="x"><xsl:value-of select="$xout"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift + 64"/></xsl:attribute>
	    <xsl:attribute name="font-size">14</xsl:attribute>
	    <xsl:value-of select="round(@variance * 100) div 100"/>
	</xsl:element>

	<xsl:element name="text">
	    <xsl:attribute name="x"><xsl:value-of select="$xout"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift + 96"/></xsl:attribute>
	    <xsl:attribute name="font-size">14</xsl:attribute>
	    <xsl:text>Last Event:</xsl:text>
	</xsl:element>
	<xsl:element name="text">
	    <xsl:attribute name="x"><xsl:value-of select="$xout"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift + 112"/></xsl:attribute>
	    <xsl:attribute name="font-size">14</xsl:attribute>
	    <xsl:value-of select="round($lastwrite div 60)"/><xsl:text> min. ago</xsl:text>
	</xsl:element>
	<xsl:element name="text">
	    <xsl:attribute name="x"><xsl:value-of select="$xout"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift + 128"/></xsl:attribute>
	    <xsl:attribute name="font-size">14</xsl:attribute>
	    <xsl:text>Outage:</xsl:text>
	</xsl:element>
	<xsl:element name="text">
	    <xsl:attribute name="x"><xsl:value-of select="$xout"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift + 144"/></xsl:attribute>
	    <xsl:attribute name="font-size">14</xsl:attribute>
	    <xsl:value-of select="$missed"/><xsl:text> sec.</xsl:text>
	</xsl:element>
	<xsl:element name="text">
	    <xsl:attribute name="x"><xsl:value-of select="$xout"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift + 160"/></xsl:attribute>
	    <xsl:attribute name="font-size">14</xsl:attribute>
	    <xsl:text>Invalid Events:</xsl:text>
	</xsl:element>
	<xsl:element name="text">
	    <xsl:attribute name="x"><xsl:value-of select="$xout"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift + 176"/></xsl:attribute>
	    <xsl:attribute name="font-size">14</xsl:attribute>
	    <xsl:value-of select="$invalid"/><xsl:text> of </xsl:text><xsl:value-of select="@records"/>
	</xsl:element>
<?}?>
	<xsl:element name="g">
	  <xsl:attribute name="transform">translate(0,<xsl:value-of select="$shift"/>) scale(<xsl:value-of select="$scale"/>)</xsl:attribute>
	
	  <xsl:element name="path">
	    <xsl:attribute name="fill">none</xsl:attribute>
	    <xsl:choose>
	        <xsl:when test="$problematic"> 
		    <xsl:attribute name="stroke">#6F0000</xsl:attribute>
		</xsl:when>
		<xsl:otherwise>
		    <xsl:attribute name="stroke">red</xsl:attribute>
		</xsl:otherwise>
	    </xsl:choose>
	    <xsl:attribute name="stroke-width">1</xsl:attribute>
	    <xsl:attribute name="d">
		<xsl:apply-templates select="Value">
		    <xsl:with-param name="size" select="$size"/>
		    <xsl:with-param name="xscale" select="$xscale"/>
		    <xsl:with-param name="ymove" select="$ymove"/>
		    <xsl:with-param name="yscale" select="$yscale"/>
		</xsl:apply-templates>
	    </xsl:attribute>
	  </xsl:element>
	</xsl:element>
      </g>
    </xsl:element>
 </xsl:template>

 <xsl:template match="//Graph[@nodata]">
    <xhtml:span class="badvalue">No Data</xhtml:span>
 </xsl:template>
</xsl:stylesheet>
