<?
require("../config.php");
header("Content-Type: application/xml");
if (isset($_GET["selected"])) $selected = 1; else $selected = 0;
echo "<?xml version=\"1.0\"?>";?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xhtml="http://www.w3.org/1999/xhtml" xmlns="http://www.w3.org/2000/svg">
 <xsl:output method="xml" version="1.0" encoding="utf-8" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"/>

 <xsl:template name="point">
    <xsl:param name="items"/>
    <xsl:param name="mmaxy"/>
    <xsl:param name="xscale"/>
    
    <xsl:choose>
	<xsl:when test="@id = 1">M1</xsl:when>
	<xsl:otherwise><xsl:value-of select="@id * $xscale"/></xsl:otherwise>
    </xsl:choose>
    
    
    <xsl:text>,</xsl:text>
    <xsl:value-of select="1 + $items - ($items * . div $mmaxy) "/>

    <xsl:if test="not(@id = $items)">
	<xsl:text> </xsl:text>
    </xsl:if>
 </xsl:template>
 
 <xsl:template match="//Graph[not(@nodata)]">
<?if ($selected) {?>
    <xsl:param name="scale">3</xsl:param>
    <xsl:param name="shift">75</xsl:param>
    <xsl:param name="maxx" select="@max_nonzero"/>

    <xsl:param name="xout" select="$scale * @items + 16"/>
<?} else {?>
    <xsl:param name="scale">1</xsl:param>
    <xsl:param name="shift">0</xsl:param>

    <xsl:param name="maxx" select="../@max_nonzero"/>
<?}?>
    <xsl:param name="xcoef" select="$maxx div @items"/>
    
    <xsl:element name="svg">
      <xsl:attribute name="width"><xsl:value-of select="2 * $shift + $scale * @items + 3"/></xsl:attribute>
      <xsl:attribute name="height"><xsl:value-of select="2 * $shift + $scale * @items + 4"/></xsl:attribute>
      <g>
        <xsl:element name="rect">
	    <xsl:attribute name="x"><xsl:value-of select="1"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift + 1"/></xsl:attribute>
	    <xsl:attribute name="width"><xsl:value-of select="$scale * @items + 1"/></xsl:attribute>
	    <xsl:attribute name="height"><xsl:value-of select="$scale * @items + 2"/></xsl:attribute>
	    <xsl:attribute name="fill">#E0E0E0</xsl:attribute>
	    <xsl:attribute name="stroke">blue</xsl:attribute>
	    <xsl:attribute name="stroke-width">2</xsl:attribute>
	</xsl:element>

<?if ($selected) {?>
	<xsl:element name="text">
	    <xsl:attribute name="x"><xsl:value-of select="1"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift + $scale * @items + 16"/></xsl:attribute>
	    <xsl:attribute name="font-size">14</xsl:attribute>
	    1
	</xsl:element>

	<xsl:element name="text">
	    <xsl:attribute name="x"><xsl:value-of select="$scale * @items - 28"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift + $scale * @items + 16"/></xsl:attribute>
	    <xsl:attribute name="font-size">14</xsl:attribute>
	    <xsl:value-of select="@items * $xcoef"/>
	</xsl:element>
	
	<xsl:element name="text">
	    <xsl:attribute name="x"><xsl:value-of select="$xout"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift + 16"/></xsl:attribute>
	    <xsl:attribute name="font-size">14</xsl:attribute>
	    <xsl:text>Center: </xsl:text><xsl:value-of select="@center"/>
	</xsl:element>
    <? $i = 0;
    foreach ($SPECTRUM_THRESHOLDS as $threshold) {?>
	<xsl:element name="text">
	    <xsl:attribute name="x"><xsl:value-of select="$xout"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift + 64 + <?echo $i * 32;?>"/></xsl:attribute>
	    <xsl:attribute name="font-size">14</xsl:attribute>
	<?if ($threshold) {?>
	    <xsl:text>Events (&gt;<?echo $threshold;?>):</xsl:text>
	<?} else {?>
	    <xsl:text>Total Events:</xsl:text>
	<?}?>
	</xsl:element>
	<xsl:element name="text">
	    <xsl:attribute name="x"><xsl:value-of select="$xout"/></xsl:attribute>
	    <xsl:attribute name="y"><xsl:value-of select="$shift + 80 + <?echo $i * 32;?>"/></xsl:attribute>
	    <xsl:attribute name="font-size">14</xsl:attribute>
	<?if ($threshold) {?>
	    <xsl:value-of select="sum(child::Value[@id &gt; <?echo $threshold;?>])"/>
	<?} else {?>
	    <xsl:value-of select="sum(child::Value)"/>
	<?}?>
	</xsl:element>
    
    <?	$i++;
    }?>
<?}?>
	<xsl:element name="g">
	  <xsl:attribute name="transform">translate(0,<xsl:value-of select="$shift"/>) scale(<xsl:value-of select="$scale"/>)</xsl:attribute>
	
	  <xsl:element name="path">
	    <xsl:attribute name="fill">none</xsl:attribute>
	    <xsl:attribute name="stroke">red</xsl:attribute>
	    <xsl:attribute name="stroke-width">1</xsl:attribute>
	    <xsl:attribute name="d">
	        <xsl:for-each select="Value[@id &lt;= $maxx]">
		    <xsl:call-template name="point">
			<xsl:with-param name="items" select="../@items"/>
			<xsl:with-param name="mmaxy"><xsl:value-of select="../../@max"/></xsl:with-param>
			<xsl:with-param name="xscale"><xsl:value-of select="1 div $xcoef"/></xsl:with-param>
		    </xsl:call-template>
		</xsl:for-each>
	    </xsl:attribute>
	  </xsl:element>
	</xsl:element>
      </g>
    </xsl:element>
 </xsl:template>
 <xsl:template match="//Graph[@nodata]">
    <xhtml:span class="badvalue">No Data</xhtml:span>
 </xsl:template>
</xsl:stylesheet>
