<?

function device_xmldata_header($detector, $device) {
    global $sub_option;
    
    echo "<div class=\"xmldata\">";
    if (!isset($_GET["iframe"])) {
	if (isset($_GET["sub"])) {
	    echo "<h4>" . $detector['type'] . " Device: " . $device . ", SubData: " . $_GET["sub"];
	} else {
	    echo "<h4>" . $detector['type'] . " Device: " . $device;
	}
	
    	if (isset($_GET["update"])) {
	    echo " (<a href=\"index.php?page=xmldata.php&amp;detector=" . $detector["name"] . "&amp;device=" . $device . $sub_option . "\">Stop Updating</a>)</h4>";
    	} else {
	    echo " (<a href=\"index.php?page=xmldata.php&amp;detector=" . $detector["name"] . "&amp;device=" . $device . $sub_option . "&amp;update\">Update</a>)</h4>";
	}
    }
}

function device_xmldata_footer($detector, $device) {
    echo "</div>";
}


function device_xmldata($detector, $device) {
    global $update_option;
    global $REPORT_NODATA_TIMEOUT;

    device_xmldata_header($detector, $device);

    if ($_GET["sub"]) 
	$data = xmldata($detector["name"], $device, $_GET["sub"]);
    else 
	$data = xmldata($detector["name"], $device, FALSE);
	
    if ($data) {
	if (!isset($_GET["iframe"])) {
	    $time = xmldata_get_time($data);
	    if ($time) $passed = time() - $time;
	    else $passed = $REPORT_NODATA_TIMEOUT + 1;

	    echo "<p class=\"updatetime\">";
	    if ($passed > $REPORT_NODATA_TIMEOUT) echo "<span class=\"highlight\">Warning</span>: <i>";
	    if ($time) {
		echo "Last data is written ";
		if ($passed > 3600) echo intval($passed/3600) . " hours";
		else if ($passed > 60) echo intval($passed/60) . " minutes";
		else echo $passed . " seconds" ;
	        echo " ago<br/>";
	    } else echo "Error detection last writeout time";
	    if ($passed > $REPORT_NODATA_TIMEOUT) echo "</i>";
	    echo "</p>";
	

	    $subs = list_filesubs(get_data_path($detector["name"], "XML"), $device);
    	    if (count($subs)) {
		echo "<p class=\"sublist\">";
		echo "SubData: ";
		
		if (isset($_GET["sub"])) {
    		    echo "<a href=\"index.php?page=xmldata.php&amp;detector=" . $detector["name"] . "&amp;device=" . $device . $update_option . "\">Base</a>";
		    $printed = 1;
		} else $printed = 0;
	        
		foreach ($subs as $sub) {
		    if ($printed) echo ", ";
		    if ((isset($_GET["sub"]))&&(!strcmp($_GET["sub"], $sub))) {
			echo $sub;
		    } else {
    			echo "<a href=\"index.php?page=xmldata.php&amp;detector=" . $detector["name"] . "&amp;device=" . $device . $update_option . "&amp;sub=" . $sub . "\">$sub</a>";
		    }
		    $printed = 1;
		}
		echo "</p>";
		echo "<br/>";
	    }
	}

	$proc = new XsltProcessor;
	$xsl = new DomDocument;
	$xsl->load("data.xslt");
	$proc->importStyleSheet($xsl);

	print $proc->transformToXML($data);
    } else {
	echo "<span class=\"highlight\">Error:</span> Failed to get data!";
    }

    device_xmldata_footer($detector, $device);
}

if (isset($_GET["update"])) $update_option="&amp;update";
else $update_option = "";

if (isset($_GET["sub"])) $sub_option="&amp;sub=" . $_GET["sub"];
else $sub_option = "";



if ($_GET["device"]) {
    set_dev();
    device_xmldata($dev, $_GET["device"]);
} else {

    $detectors = list_detectors();
    foreach ($detectors as $detector) {
	$dev = get_device($detector);
	if ($dev) {
	    for ($i = 0; $i < $dev["subdevices"];$i++) {
		if ($dev["subdevices"]>1) $device = $dev["name"] . "-" . ($i+1);
		else $device = $dev["name"];
		
		device_xmldata($dev, $device);
		echo "<br/><br/>";
 	    }
	} else {
	    device_xmldata_header($dev, $device);
	    echo "<span class=\"highlight\">Error:</span> Out of operation!";
	    device_xmldata_footer($dev, $device);
	}
	echo "<br/>";
    }
}
?>